unit uResources;
//begin 7.07.2008
// v 0.1.2.06 - 4.08.2008
//end --

interface

uses OMEGA,uTypes;

type tResources=object
      Texture:array of tTexture;
      QuantityTexture:integer;

      Object2D:array of tObject2D;
      QuantityObject2D:integer;

      Object3D:array of tObject3D;
      QuantityObject3D:integer;

      ErorTexture:tTexture;

      procedure Init;

//////  ///////////////////////////////////////////////////////
      procedure AddTexture(ScriptName:string);
      procedure Sorting;

      procedure UpLoadFamily(FamilyName:string);
      procedure UnLoadFamily(FamilyName:string);

      function FindTexture(TextureName:string):tTexture;
      function FindIDTexture(TextureName:string):integer;

////////////////////////////////////////////////////////////////////////////////
      procedure AddObject2D(ScriptName:string);
     end;

implementation

////////////////////////////////////////////////////////////////////////////////

procedure tResources.Init;
begin
//    
ErorTexture.Name:='EROR';
ErorTexture.Family:='SYSTEM';
ErorTexture.W:=256;
ErorTexture.H:=256;
ErorTexture.Alpha:=255;
ErorTexture.TransparentColour:=-1;
ErorTexture.UseMask:=false;
ErorTexture.Animated:=false;
ErorTexture.FileName:='error.bmp';
ErorTexture.Texture:=tex_loadfromfile('error.bmp',-1,TEX_DEFAULT_2D);
ErorTexture.Loaded:=true;

QuantityTexture:=0;
SetLength(Texture,QuantityTexture);

QuantityObject2D:=0;
SetLength(Object2D,QuantityObject2D);

QuantityObject3D:=0;
SetLength(Object3D,QuantityObject3D);

LOG_AddMessage(2,'   ');

end;

////////////////////////////////////////////////////////////////////////////////
//////  ///////////////////////////////////////////////////////

procedure tResources.AddTexture(ScriptName:string);
begin

QuantityTexture:=QuantityTexture+1;
SetLength(Texture,QuantityTexture);

Texture[QuantityTexture-1].LoadTexture(ScriptName);

Sorting;

LOG_AddMessage(2,PChar('   '+ScriptName));

end;

procedure tResources.Sorting;
var i1,i2,i3:integer;
    t:tTexture;
begin
//        
//   

for i1:=0 to QuantityTexture-2 do
 for i2:=i1+1 to QuantityTexture-1 do
  if Texture[i1].Name<Texture[i2].Name then begin
   t:=Texture[i2];

   for i3:=i2 downto i1+1 do
    Texture[i3]:=Texture[i3-1];

   Texture[i1]:=t;
  end;

end;

procedure tResources.UpLoadFamily(FamilyName:string);
var i:integer;
begin

for i:=0 to QuantityTexture-1 do
 if texture[i].Family=FamilyName then texture[i].UpLoad;

end;

procedure tResources.UnLoadFamily(FamilyName:string);
var i:integer;
begin

for i:=0 to QuantityTexture-1 do
 if texture[i].Family=FamilyName then texture[i].UnLoad;

end;

function tResources.FindTexture(TextureName:string):tTexture;
var i:integer;
    t:boolean;
begin

t:=true;

{for i:=0 to QuantityTexture-1 do
 if texture[i].Name=TextureName then begin
  if not Texture[i].Loaded then Texture[i].UpLoad;
   FindTexture:=Texture[i];
   t:=false;
   Break;
  end;}

if TextureName[1]<'M' then begin
 for i:=0 to QuantityTexture-1 do
  if texture[i].Name=TextureName then begin
   if not Texture[i].Loaded then Texture[i].UpLoad;
   FindTexture:=Texture[i];
   t:=false;
   Break;
  end;
end else begin
 for i:=QuantityTexture-1 downto 0 do
  if texture[i].Name=TextureName then begin
   if not Texture[i].Loaded then Texture[i].UpLoad;
   FindTexture:=Texture[i];
   t:=false;
   Break;
  end;
end;

if t then begin
 FindTexture:=ErorTexture;
 LOG_AddMessage(0,PChar('   '+TextureName));
end;

end;

function tResources.FindIDTexture(TextureName:string):integer;
var i:integer;
    t:boolean;
begin

t:=true;

for i:=0 to QuantityTexture-1 do
 if texture[i].Name=TextureName then begin
  FindIDTexture:=i;
  t:=false;
  Break;
 end;

if TextureName[1]<'M' then begin
 for i:=0 to QuantityTexture-1 do
  if texture[i].Name=TextureName then begin
   FindIDTexture:=i;
   t:=false;
   Break;
  end;
end else begin
 for i:=QuantityTexture-1 downto 0 do
  if texture[i].Name=TextureName then begin
   FindIDTexture:=i;
   t:=false;
   Break;
  end;
end;

if t then begin
 FindIDTexture:=-1;
 LOG_AddMessage(0,PChar('   '+TextureName));
end;

end;

////////////////////////////////////////////////////////////////////////////////

procedure tResources.AddObject2D(ScriptName: string);
begin

QuantityObject2D:=QuantityObject2D+1;
SetLength(Texture,QuantityObject2D);

Object2D[QuantityObject2D-1].LoadObject2D(ScriptName);

LOG_AddMessage(2,PChar(' 2D   '+ScriptName));

end;

end.
