unit uTypes;
//begin 14.07.2008
// v 0.1.2.12 - 8.08.2008
//end --

interface

uses OMEGA,
     uProcedures,
     uScript;

type // 
     tScene=(sLoadMap,sIntoGame,sMenu,sOptions,sGame,sAutor);
     //   
     tOptionsScene=(sVidio,sAudio,sControl);
     //  
     tGameScene=(sChangePlayer,sChangeLevel,sFigth);

//  
//  
type tFrameScheme=record
      FrameScript:tScript;
     end;

// 
type tTexture=object
      Texture:PTexture;                            // 
      Name,Family:string;                         //    

      W,H,Alpha,TransparentColour:integer;        //,    
      FW,FH:integer;                             //  

      NFrame,QFrame:integer;                   //   - 
      FramScheme:tFrameScheme;                // 

      Animated,                                     // ?
      UseMask,                                     // ?
      Loaded:boolean;                             //   ?

      FileName,MaskFileName:string;                //      

      procedure LoadTexture(ScriptName:string);   //   
      procedure UnLoad;                          //   
      procedure UpLoad;                         //   

      procedure DefaultDraw(x,y:integer;
                            frame:integer=1;
                            angle:integer=0;
                            flags:integer=1);           //   
      procedure UserDraw(x,y:integer;
                         wx,hx:integer;
                         alph:integer=255;
                         angle:integer=0;
                         frame:integer=1;
                         flags:integer=1);  //   
     end;

// 2 
     tObject2D=object
      Name:string;                   // 
      Texture:tTexture;             // 
      Alpha:integer;               //  (?  ?)

      X,Y:integer;                //
      W,H:integer;               //  
      Size:real;                // 

      oe:TPolyLine2D;          //  
      oe2:TAABB2D;            //  

      procedure LoadObject2D(ScriptName:string);

      procedure DefaultDraw;
      procedure UserDraw(hx,hy:integer;
                         sz:real=1;
                         alph:integer=255);
     end;

// 3 
     tObject3D=object
     end;

implementation

uses uGData,
     omegapng,
     uApllicationsConst;
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure tTexture.LoadTexture(ScriptName:string);
var Script:tScript;
begin
//    
Script.LoadScript(ScriptName);
//   
Name:=TransferTopRegister(Script.GetStrParametre('NAME'));
Family:=TransferTopRegister(Script.GetStrParametre('FAMILY'));
//    
FileName:=Script.GetStrParametre('TEXTURE');
//,   
//     
if Script.GetBolParametre('USE_MASK') then  begin
 MaskFileName:=Script.GetStrParametre('MASK');
 UseMask:=true;
end else UseMask:=false;
//   ,      
TransparentColour:=Script.GetIntParametre('TC');
Alpha:=Script.GetIntParametre('ALPHA');
H:=Script.GetIntParametre('W');
W:=Script.GetIntParametre('H');
//,   
Animated:=Script.GetBolParametre('ANIMATED');
//    
FW:=Script.GetIntParametre('FW');
FH:=Script.GetIntParametre('FH');
// - 
if Animated then QFrame:=(W  div FW)*(H div FH);
//,       
Loaded:=false;
end;

procedure tTexture.UnLoad;
begin
//   
Tex_Free(Texture);
Loaded:=false;
end;

procedure tTexture.UpLoad;
var s:string;
begin
//   
//    ,    
//      
if Pos('.png',FileName)<>0 then Texture:=Tex_LoadPNGFromFile(PChar(DFld+FileName),-1,TEX_DEFAULT_2D)
else if UseMask then begin
 Tex_LoadMaskFromFile(PChar(DFld+MaskFileName));
 Texture:=tex_loadfromfile(pChar(DFld+FileName),TransparentColour,TEX_DEFAULT_2D or TEX_USEMASK);
 Tex_FreeMask;
end else Texture:=tex_loadfromfile(pChar(DFld+FileName),TransparentColour,TEX_DEFAULT_2D);
//  ,    
if Animated then Tex_SetFramesSize(Texture,FW,FH);
//,   
Loaded:=true;
end;

procedure tTexture.DefaultDraw(x,y:integer;
                               frame:integer=1;
                               angle:integer=0;
                               flags:integer=1);
begin
//       ,  
if not Loaded then UpLoad;
if Animated then ASprite_Draw(texture,x,y,fw,fh,frame,alpha,angle,flags)
 else SSprite_Draw(texture,x,y,w,h,alpha,angle,flags);
end;

procedure tTexture.UserDraw(x,y:integer;
                            wx,hx:integer;
                            alph:integer=255;
                            angle:integer=0;
                            frame:integer=1;
                            flags:integer=1);
begin
//       ,  
if not Loaded then UpLoad;
if Animated then ASprite_Draw(texture,x,y,wx,hx,frame,alph,angle,flags)
 else SSprite_Draw(texture,x,y,wx,hx,alph,angle,flags);
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure tObject2D.LoadObject2D(ScriptName:string);
var Script:tScript;
    t,c,i,k:integer;
begin

Script.LoadScript(ScriptName);

Name:=Script.GetStrParametre('NAME');
Texture:=Res.FindTexture(Script.GetStrParametre('TEXTURE_NAME'));
Texture.UpLoad;
Alpha:=Script.GetIntParametre('ALPHA');
W:=Script.GetIntParametre('W');
H:=Script.GetIntParametre('H');
Size:=1;

t:=Script.GetIntParametre('QPOINT');
SetLength(oe.Points,t);
oe.Count :=t-1;
c:=Script.FindIDParametre('QPOINT');
for i:=c+1 to c+t do begin
 k:=Script.ScriptParametreArray[i].Int;
 oe.Points[i-c-1].X:=k mod 1000;
 k:=k div 1000;
 oe.Points[i-c-1].Y:=k mod 1000;
end;

end;

procedure tObject2D.DefaultDraw;
begin
end;

procedure tObject2D.UserDraw(hx,hy:integer;
                             sz:real=1;
                             alph:integer=255);
begin
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////



end.
