unit uGUI;
//begin 01.08.2008
//now v 0.1.4.40 - 7.08.2008
//end --

interface

uses OMEGA;

type tTextColor=record
      Normal  : integer;
      Select  : integer;
      Focus   : integer;
      Disable : integer;
     end;

type tGUIObject=object
      x,y,w,h:integer;
      color:tTextColor;

      visibl,
      activ,
      focus,
      select:boolean;

      oe:TAABB2D;

      procedure Init;
     end;

type tAP=procedure( Key:integer; Sender,Parent:tGUIObject );

type tButton=object (tGUIObject)
      tx1,tx2,tx3,tx4:string;
      caption:string;

      pressed:boolean;

      Sender,Parent:tGUIObject;

      OnClic:tAP;

      procedure Init(hx,hy:integer;
                     hw,hh:integer;
                     clr:tTextColor;
                     nm1,nm2,nm3,nm4:string;
                     cpt:string;
                     sndr,prnt:tGUIObject;
                     oclc:tAP;
                     prsd:boolean=false);
      procedure ReInit(hx,hy:integer);
      procedure Draw;
      procedure Process;
     end;

type tWindow=object (tGUIObject)
      texture:PTexture;

      wcolor:integer;

      caption:string;

      Sender,Parent:tGUIObject;

      procedure Init(hx,hy:integer;
                     hw,hh:integer;
                     wc:integer;
                     cpt:string;
                     sndr,prnt:tGUIObject);
      procedure Draw;
      procedure Process;
     end;

implementation

uses uGData,uConst;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure tGUIObject.Init;
begin

x:=0; y:=0; w:=0; h:=0;

color.Normal :=0; color.Select  :=0;
color.Focus  :=0; color.Disable :=0;

visibl :=true;  activ  :=true;
focus  :=false; select :=false;

oe.X     :=x; oe.Y      :=y;
oe.Width :=w; oe.Height :=h;

end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure tButton.Init(hx,hy:integer;
                       hw,hh:integer;
                       clr:tTextColor;
                       nm1,nm2,nm3,nm4:string;
                       cpt:string;
                       sndr,prnt:tGUIObject;
                       oclc:tAP;
                       prsd:boolean=false);
begin

color:=clr; caption:=cpt;

tx1:=nm1; tx2:=nm2; tx3:=nm3; tx4:=nm4;

sender:=sndr; parent:=prnt;

x:=Parent.x+hx; y:=Parent.y+hy;
w:=hw;          h:=hh;

oe.X     :=x; oe.Y      :=y;
oe.Width :=w; oe.Height :=h;

visibl  :=true;  activ  :=true;
focus   :=false; select :=false;
pressed :=prsd;

OnClic:=oclc;

end;

procedure tButton.ReInit(hx,hy:integer);
begin

x:=Parent.x+hx; y:=Parent.y+hy;

end;

procedure tButton.Draw;
var t0,t1,t2:integer;
begin

if visibl then begin
 t0:=trunc(Text_GetWidth(GUIFont,PChar(Caption),1));
 t0:=(w-t0) div 2;
 t0:=x+t0;
 t1:=y+(h div 2)-10;
 t2:=color.Disable;

 if activ then begin
  if pressed then Res.FindTexture(tx2).UserDraw(x,y,w,h) else Res.FindTexture(tx1).UserDraw(x,y,w,h);

  if select then t2:=color.Select else t2:=color.Normal;
  if focus  then t2:=color.Focus;
  Text_Draw(GUIFont,t0,t1,PChar(Caption),1,0,255,t2);

  if focus then begin
   Res.FindTexture(tx3).UserDraw(x,y,w,h,180);
   Res.FindTexture(tx4).UserDraw(x,y,w,h);
  end else Res.FindTexture(tx3).UserDraw(x,y,w,h,100);

 end else begin
  Res.FindTexture(tx2).UserDraw(x,y,w,h);
  Text_Draw(GUIFont,t0,t1,PChar(Caption),1,0,255,t2);
 end;
end;

end;

procedure tButton.Process;
begin
if col_pointinaabb(mouse_x,mouse_y,@oe) then focus:=true else focus:=false;
if focus and mouse_down(m_lbutton) then pressed:=true else pressed:=false;
if focus and mouse_press(m_lbutton) then OnClic(m_lbutton,Sender,Parent);
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure tWindow.Init(hx,hy:integer;
                       hw,hh:integer;
                       wc:integer;
                       cpt:string;
                       sndr,prnt:tGUIObject);
var i1,i2:integer;
begin

visibl  :=true;  activ  :=true;
focus   :=false; select :=false;

caption:=cpt;
wcolor:=wc;

Sender:=sndr; Parent:=prnt;

x:=Parent.x+hx; y:=Parent.y+hy;
w:=hw;          h:=hh;

end;

procedure tWindow.Draw;
var i,i1,i2:integer;
begin

if visibl then begin
 FX_SetColorMix(WColor);
 for i1:=1 to w-3 do
  for i2:=1 to h-3 do
   Res.FindTexture('WND_FON').DefaultDraw(x+i1*16,y+i2*16,1,0,8);
 for i:=1 to h-3 do begin
  Res.FindTexture('WND_LEFT_EDGE').DefaultDraw(x,y+i*16,1,0,8);
  Res.FindTexture('WND_RIGTH_EDGE').DefaultDraw(x+16*(w-2),y+i*16,1,0,8);
 end;
 for i:=1 to w-3 do begin
  Res.FindTexture('WND_TOP_EDGE').DefaultDraw(x+i*16,y,1,0,8);
  Res.FindTexture('WND_BOTTON_EDGE').DefaultDraw(x+i*16,y+16*(h-2),1,0,8);
 end;
 Res.FindTexture('WND_TOP_LEFT_EDGE').DefaultDraw(x,y,1,0,8);
 Res.FindTexture('WND_TOP_RIGTH_EDGE').DefaultDraw(x+16*(w-2),y,1,0,8);
 Res.FindTexture('WND_BOTTON_LEFT_EDGE').DefaultDraw(x,y+16*(h-2),1,0,8);
 Res.FindTexture('WND_BOTTON_RIGTH_EDGE').DefaultDraw(x+16*(w-2),y+16*(h-2),1,0,8);
end;

end;

procedure tWindow.Process;
begin
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

end.
