unit uGameTypes;
//only for Dog_Drem!
//v 0.6

interface

uses OMEGA,uTypes;

type tState=(tRest,           //
             tRun,           //
             tSting,        //
             tTiredToRun,  //  :)
             tDead);

type tActor=object
      X,Y:real;                 //
      VX,VY:real;              //

      Health,MaxHealth,             //   . 
      Weariness,MaxWeariness:real;  //   . 

      State:tState;                 //
      KuzKuz:boolean;

      OE:TAABB2D;

      Tex:array [1..5] of tTexture;      //
     end;

type tPlayer=object (tActor)
      BOBO_TEX_NUMB:byte;

      procedure Init;
      procedure Draw;
      procedure Process;
     end;

type tDog=object (tActor)
      Pl:^tPlayer;
      Speed:real;

      procedure Init(P:Pointer);
      procedure Draw;
      procedure Process;
     end;

type tWorld=object
      Player:tPlayer;

      Dogs:array of tDog;
      CountDogs:integer;

      Time:single;
      Pause:boolean;

      procedure Init;
      procedure AddDog;
      procedure Draw;
      procedure Process;
     end;

implementation

uses uConst,uGData,uGame;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure tPlayer.Init;
begin

Mouse_Lock;

X:=  ScrW/2;  Y:=  ScrH/2;
VX:= 0;       VY:= 0;

case GCmplx of
 tEasy:begin
        Health:=    500;  MaxHealth:=   500;
        Weariness:= 1000; MaxWeariness:= 1000;
       end;
 tNormal:begin
          Health:=    300;  MaxHealth:=  300;
          Weariness:= 700; MaxWeariness:= 700;
         end;
 tHard:begin
        Health:=    180;  MaxHealth:=  180;
        Weariness:= 500; MaxWeariness:= 500;
       end;
end;

State:=tRest;
KuzKuz:=false;
BOBO_TEX_NUMB:=1;

Tex[1]:=Res.FindTexture('NORMAL_PLAYER');  Tex[2]:=Res.FindTexture('FUNY_PLAYER');
Tex[3]:=Res.FindTexture('WATER_PLAYER');   Tex[4]:=Res.FindTexture('BOBO_PLAYER_1');
Tex[5]:=Res.FindTexture('BOBO_PLAYER_2');

Oe.X:=X-22;
Oe.Y:=Y-44;
Oe.Width:=42;
Oe.Height:=56;

end;

procedure tPlayer.Draw;
begin

if KuzKuz then
 Case BOBO_TEX_NUMB of
  1:Tex[4].DefaultDraw(Trunc(X-18),Trunc(Y-38),1,0,1);
  2:Tex[5].DefaultDraw(Trunc(X-18),Trunc(Y-38),1,0,1);
 end else
 Case State of
  tRest:Tex[2].DefaultDraw(Trunc(X-18),Trunc(Y-38),1,0,1);
  tRun:Tex[1].DefaultDraw(Trunc(X-18),Trunc(Y-38),1,0,1);
  tTiredToRun:Tex[3].DefaultDraw(Trunc(X-18),Trunc(Y-38),1,0,1);
 end;

end;

procedure tPlayer.Process;
begin

if State<>tTiredToRun then begin VX:=VX+Mouse_DeltaX/30; VY:=VY+Mouse_DeltaY/30;end
 else if Weariness>(MaxWeariness*0.8) then State:=tRest;

if Weariness<(MaxWeariness*0.1) then  State:=tTiredToRun;

X:=   X+VX; Y:=   Y+VY;
Oe.X:=X-22; Oe.Y:=Y-44;

if State=tTiredToRun then Weariness:=Weariness-4*(Abs(VX)+Abs(VY)) else Weariness:=Weariness-(Abs(VX)+Abs(VY));

VX:=0.9*VX; if Abs(VX)<0.0008 then VX:=0;
VY:=0.9*VY; if Abs(VY)<0.0008 then VY:=0;
if (VX=0) and (VY=0) and (State<>tTiredToRun)
 then State:=tRest else if State=tRest then State:=tRun;

if Weariness<(MaxWeariness-15) then Weariness:=Weariness+15 else Weariness:=MaxWeariness;

if X>(ScrW-18) then begin X:=(ScrW-18); VX:=0;end;
if Y>(ScrH-10) then begin Y:=(ScrH-10); VY:=0;end;
if X<18 then begin X:=18; VX:=0;end;
if Y<38 then begin Y:=38; VY:=0;end;

if KuzKuz then Health:=Health-5;

Mouse_Lock;

end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure tDog.Init(P:Pointer);
begin

Pl:=P;

if Pl.X<500 then X:=900 else X:=100;
if Pl.Y<380 then Y:=680 else Y:=100;
//X:=  100; Y:=  100;
VX:= 0;   VY:= 0;

case GCmplx of
 tEasy:begin
        Weariness:= 1500; MaxWeariness:= 1500;
        Speed:=1;
       end;
 tNormal:begin
          Weariness:= 1050; MaxWeariness:= 1050;
          Speed:=1.5;
         end;
 tHard:begin
        Weariness:= 750; MaxWeariness:= 750;
        Speed:=2;
       end;
end;

State:=tRest;
KuzKuz:=false;

Tex[1]:=Res.FindTexture('NORMAL_DOG');
Tex[2]:=Res.FindTexture('WATER_DOG');
Tex[3]:=Res.FindTexture('KUZKUZ_DOG');

Oe.X:=X-25;
Oe.Y:=Y-27;
Oe.Width:=50;
Oe.Height:=48;

end;

procedure tDog.Draw;
begin

if KuzKuz then Tex[3].DefaultDraw(Trunc(X-21),Trunc(Y-23),1,0,1) else
 Case State of
  tRest:Tex[1].DefaultDraw(Trunc(X-21),Trunc(Y-23),1,0,1);
  tRun:Tex[1].DefaultDraw(Trunc(X-21),Trunc(Y-23),1,0,1);
//  tSting:Tex[3].DefaultDraw(Trunc(X-21),Trunc(Y-23),1,0,1);
  tTiredToRun:Tex[2].DefaultDraw(Trunc(X-21),Trunc(Y-23),1,0,1);
 end;


end;

procedure tDog.Process;
var a:integer;
    l:real;
begin

if State<>tTiredToRun then begin
 A:=M_FindAngle(trunc(X),trunc(Y),trunc(Pl.X),trunc(Pl.Y));
 VX:=VX+Speed*Cos(A);
 VY:=VY+Speed*Sin(A);
end else if Weariness>(MaxWeariness*0.8) then State:=tRest;

if Weariness<(MaxWeariness*0.1) then  State:=tTiredToRun;

X:=X+VX;    Y:=Y+VY;
Oe.X:=X-25; Oe.Y:=Y-27;

if State=tTiredToRun then Weariness:=Weariness-4*(Abs(VX)+Abs(VY)) else Weariness:=Weariness-(Abs(VX)+Abs(VY));

VX:=0.9*VX; if Abs(VX)<0.0008 then VX:=0;
VY:=0.9*VY; if Abs(VY)<0.0008 then VY:=0;
if (VX=0) and (VY=0) and (State<>tTiredToRun)
 then State:=tRest else if State=tRest then State:=tRun;

if Weariness<(MaxWeariness-15) then Weariness:=Weariness+15 else Weariness:=MaxWeariness;

if X>(ScrW-21) then begin X:=(ScrW-21); VX:=0;end;
if Y>(ScrH-19) then begin Y:=(ScrH-19); VY:=0;end;
if X<21 then begin X:=21; VX:=0;end;
if Y<23 then begin Y:=23; VY:=0;end;

end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure tWorld.Init;
begin

Randomize;
Pause:=false;

Time:=0;

CountDogs:=0;
SetLength(Dogs,CountDogs);

Player.Init;

AddDog;

end;

procedure tWorld.AddDog;
begin

Inc(CountDogs);
SetLength(Dogs,CountDogs);
Dogs[CountDogs-1].Init(@Player);

end;

procedure tWorld.Draw;
var i:integer;
begin

For i:=0 to CountDogs-1 do
 Dogs[i].Draw;

Player.Draw;

end;

procedure tWorld.Process;
var i:integer;
begin

if Key_Press(k_ctrl) then Pause:=true else Pause:=false;

if not Pause then begin
 Player.Process;

 for i:=0 to CountDogs-1 do begin
  Dogs[i].Process;
  if Col_AABB(@Dogs[i].oe,@Player.oe) then begin
   Player.KuzKuz:=true;
   if Player.BOBO_TEX_NUMB=0 then Player.BOBO_TEX_NUMB:=Random(2)+1;
   Dogs[i].KuzKuz:=true;
  end else begin
   Player.KuzKuz:=false;
   Player.BOBO_TEX_NUMB:=0;
   Dogs[i].KuzKuz:=false;
  end;
 end;

 Time:=Time+20;

 if trunc(Time) mod 20000=0 then AddDog;

 if Player.Health<=0 then begin
  Pause:=true;
  EndGame(Time,GCmplx);
 end;

end;

end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

end.
