unit uScript;
//begin 7.07.2008
// v0.1.2.28 - 14.08.2008   (not last!, Last v0.2.1.12 - 26.08.2008 in /Resources_Project)
//end --

interface

type
//  : , ,   
     tParametreType=(INT,FLOAT,STRNG,BOL);

// (    )
     tParametre=record
      Int:integer;        //
      Float:real;        //
      Str:string;       //
      Bol:Boolean;     // 

      ParametreType:tParametreType;    // 
      Name:string;                    // 
     end;

//
     tScript=object
      ScriptName:string;      // 
      ScriptFile:string;     // 

      ScriptParametreArray:array of tParametre;   //     
      ScriptLength:integer;

      StartScriptParametre,          //  
      StopScriptParametre:string;   //  

      ErorName:widestring;
              // 
//////  ////////////////////////////////////////////////////////
      procedure LoadScript(FileName:string);         //  
      procedure NewScript(SN,StrSP,StpSP:string);   //  
      procedure SaveScript(FileName:string);       //  
      procedure CloseScript;                      // 

////// ////////////////////////////////////////////////////////////
      procedure StartScript;                    // 
      procedure StopScript;                    // 

////// //////////////////////////////////////////////////////
      function GetParametre(ParametreName:string):tParametre;     // 
      function GetIntParametre(ParametreName:string):integer;    //  . 
      function GetFloatParametre(ParametreName:string):real;    // 
      function GetStrParametre(ParametreName:string):string;   // 
      function GetBolParametre(ParametreName:string):boolean; // 
      function FindIDParametre(ParametreName:string):integer;   //     

////// /////////////////////////////////////////////////////
      function AddIntParametre(ParametreName:string;ParametreValue:integer):integer;     // 
      function AddFloatParametre(ParametreName:string;ParametreValue:real):integer;     // 
      function AddStrParametre(ParametreName:string;ParametreValue:string):integer;    // 
      function AddBolParametre(ParametreName:string;ParametreValue:boolean):integer;  //  

////// /////////////////////////////////////////////////////////////
      procedure Eror;   //    

     end;

implementation

uses SysUtils,OMEGA;

////////////////////////////////////////////////////////////////////////////////
//////  ////////////////////////////////////////////////////////

procedure tScript.LoadScript(FileName:string);
var DF:textfile;
    Symbol:string[1];
    Str:string;
    i,NumberLine:integer;
    BeEror:boolean;
begin

ErorName:=''; BeEror:=false;

//  
if not FileExists(FileName)then begin
 ErorName:=FileName+' :   '; BeEror:=true; Eror;
end;

//     
if not BeEror then begin
 ScriptFile:=FileName;

 Assignfile(DF,FileName);
 Reset(DF);
//      
 NumberLine:=1;

//   ; -    
//     
 repeat
  Read(DF,Symbol);
  If Symbol=';' then begin
   Readln(DF); NumberLine:=NumberLine+1;
  end;
 until Symbol<>';';

// ,     /,     
 If Symbol<>'/' then begin
  ErorName:=ErorName+FileName+'('+IntToStr(NumberLine)+'):   ,  !';
  closefile(DF);
  Eror;
 end;
//  
 Str:=''; Symbol:='';
 repeat
  Str:=Str+Symbol; Read(DF,Symbol);
 until Symbol='/';
 ScriptName:=Str;
//  
 Str:=''; Symbol:='';
 repeat
  Str:=Str+Symbol; Read(DF,Symbol);
 until Symbol='/';
 ScriptLength:=StrToInt(Str);
//  
 SetLength(ScriptParametreArray,ScriptLength);
//    
 Readln(DF); NumberLine:=NumberLine+1;

//   ; -    
//     
 repeat
  Read(DF,Symbol);
  If Symbol=';' then begin
   Readln(DF); NumberLine:=NumberLine+1;
  end;
 until Symbol<>';';

//  
 if Symbol<>'*' then begin
  ErorName:=ErorName+FileName+'('+IntToStr(NumberLine)+'):   !';
  BeEror:=true;
 end;
 Str:=''; Symbol:='';
 repeat
  Str:=Str+Symbol; Read(DF,Symbol);
 until Symbol='/';
 StartScriptParametre:=Str;
//    
 Readln(DF); NumberLine:=NumberLine+1;


//   ; -    
//     
 repeat
  Read(DF,Symbol);
  If Symbol=';' then begin
   Readln(DF); NumberLine:=NumberLine+1;
  end;
 until Symbol<>';';

//  
 if Symbol<>'*' then begin
  ErorName:=ErorName+FileName+'('+IntToStr(NumberLine)+'):   !';
  BeEror:=true;
 end;
 Str:=''; Symbol:='';
 repeat
  Str:=Str+Symbol; Read(DF,Symbol);
 until Symbol='/';
 StopScriptParametre:=Str;

//  
 for i:=0 to ScriptLength-1 do begin
//      
  Readln(DF); NumberLine:=NumberLine+1;
//   
  repeat
   Read(DF,Symbol);
   If Symbol=';' then begin
    Readln(DF); NumberLine:=NumberLine+1;
   end;
  until Symbol<>';';
//    
  If Symbol<>'[' then begin
   ErorName:=ErorName+#13+FileName+'('+IntToStr(NumberLine)+'):    ';
   BeEror:=true; Continue;
  end else begin
// 
   Str:=''; Symbol:='';
   repeat
    Str:=Str+Symbol; Read(DF,Symbol);
   until Symbol=']';
   ScriptParametreArray[i].Name:=Str;
//   - 
//   
   repeat
    Read(DF,Symbol);
   until Symbol='*';
   Str:=''; Symbol:='';
   repeat
    Str:=Str+Symbol; Read(DF,Symbol);
   until Symbol='*';
   if Str='INT' then ScriptParametreArray[i].ParametreType:=INT
    else if Str='FLOAT' then ScriptParametreArray[i].ParametreType:=FLOAT
     else if Str='STRNG' then ScriptParametreArray[i].ParametreType:=STRNG
      else if Str='BOL' then ScriptParametreArray[i].ParametreType:=BOL
       else begin
        ErorName:=ErorName+#13+FileName+'('+IntToStr(NumberLine)+'):    ';
        BeEror:=true; Continue;
       end;
//   - 
//   
   repeat
    Read(DF,Symbol);
   until Symbol='(';
   Str:=''; Symbol:='';
   repeat
    Str:=Str+Symbol; Read(DF,Symbol);
   until Symbol=')';
   Case ScriptParametreArray[i].ParametreType of
    INT:ScriptParametreArray[i].Int:=StrToInt(Str);
    FLOAT:ScriptParametreArray[i].Float:=StrToFloat(Str);
    STRNG:ScriptParametreArray[i].Str:=Str;
    BOL:ScriptParametreArray[i].Bol:=Str='true';
   End;
  end;
 end;
 closefile(DF);
end;
//  ,    
//   
If BeEror then begin
 Eror;
end else begin
 Assignfile(DF,'ScriptEror.txt'); Rewrite(DF); CloseFile(DF);
end;

end;

procedure tScript.NewScript(SN,StrSP,StpSP:string);
begin
//  
ScriptLength:=0;
SetLength(ScriptParametreArray,ScriptLength);
//   
ScriptName:=SN;
StartScriptParametre:=StrSP;
StopScriptParametre:=StpSP;

end;

procedure tScript.SaveScript(FileName:string);
var DF:textfile;
    i,t:integer;
begin

Assignfile(DF,FileName);
Rewrite(DF);
Writeln(DF,'/',ScriptName,'/',ScriptLength,'/');
Writeln(DF,'*',StartScriptParametre,'/');
Writeln(DF,'*',StopScriptParametre,'/');
t:=ScriptLength-1;
For i:=0 to t do begin
 Write(DF,'[',ScriptParametreArray[i].Name,'] *');
 if ScriptParametreArray[i].ParametreType=INT then Writeln(DF,'INT* (',ScriptParametreArray[i].Int,')');
 if ScriptParametreArray[i].ParametreType=FLOAT then Writeln(DF,'FLOAT* (',ScriptParametreArray[i].Float,')');
 if ScriptParametreArray[i].ParametreType=BOL then Writeln(DF,'BOL* (',ScriptParametreArray[i].Bol,')');
 if ScriptParametreArray[i].ParametreType=STRNG then Writeln(DF,'STRNG* (',ScriptParametreArray[i].Str,')');
end;
Closefile(DF);

end;

procedure tScript.CloseScript;
begin
//  
ScriptFile:='';
ScriptName:='';
ScriptLength:=0;
SetLength(ScriptParametreArray,ScriptLength);

end;

////////////////////////////////////////////////////////////////////////////////
////// ////////////////////////////////////////////////////////////

procedure tScript.StartScript;
begin
end;

procedure tScript.StopScript;
begin
end;

////////////////////////////////////////////////////////////////////////////////
////// //////////////////////////////////////////////////////

function tScript.GetParametre(ParametreName:string):tParametre;
var t:boolean;
    i:integer;
begin
// -   
t:=true;
// 
// ,    
for i:=0 to ScriptLength-1 do
 if ScriptParametreArray[i].Name=ParametreName then begin
  GetParametre:=ScriptParametreArray[i];
  t:=false;
 end;
//   ,   
if t then begin
 ErorName:=ErorName+ScriptFile+#13+'     - '+ParametreName;
 Eror;
end;

end;

function tScript.GetIntParametre(ParametreName:string):integer;
var t:boolean;
    i:integer;
begin
// -   
t:=true;
// 
// ,    
for i:=0 to ScriptLength-1 do
 if ScriptParametreArray[i].Name=ParametreName then begin
  GetIntParametre:=ScriptParametreArray[i].Int;
  t:=false;
 end;
//   ,   
if t then begin
 ErorName:=ErorName+ScriptFile+#13+'     - '+ParametreName;
 Eror;
end;

end;

function tScript.GetFloatParametre(ParametreName:string):real;
var t:boolean;
    i:integer;
begin
// -   
t:=true;
// 
// ,    
for i:=0 to ScriptLength-1 do
 if ScriptParametreArray[i].Name=ParametreName then begin
  GetFloatParametre:=ScriptParametreArray[i].Float;
  t:=false;
 end;
//   ,   
if t then begin
 ErorName:=ErorName+ScriptFile+#13+'     - '+ParametreName;
 Eror;
end;
end;

function tScript.GetStrParametre(ParametreName:string):string;
var t:boolean;
    i:integer;
begin
// -   
t:=true;
// 
// ,    
for i:=0 to ScriptLength-1 do
 if ScriptParametreArray[i].Name=ParametreName then begin
  GetStrParametre:=ScriptParametreArray[i].Str;
  t:=false;
 end;
//   ,   
if t then begin
 ErorName:=ErorName+ScriptFile+#13+'     - '+ParametreName;
 Eror;
end;

end;

function tScript.GetBolParametre(ParametreName:string):boolean;
var t:boolean;
    i:integer;
begin
// -   
t:=true;
// 
// ,    
for i:=0 to ScriptLength-1 do
 if ScriptParametreArray[i].Name=ParametreName then begin
  GetBolParametre:=ScriptParametreArray[i].Bol;
  t:=false;
 end;
//   ,   
if t then begin
 ErorName:=ErorName+ScriptFile+#13+'     - '+ParametreName;
 Eror;
end;

end;

function tScript.FindIDParametre(ParametreName:string):integer;
var t:boolean;
    i:integer;
begin
//,     
t:=true;
//    
//      ,
//       
for i:=0 to ScriptLength-1 do
 if ScriptParametreArray[i].Name=ParametreName then begin
  FindIDParametre:=i;
  t:=false;
 end;
//   ,    
if t then begin
 ErorName:=ErorName+ScriptFile+#13+'     - '+ParametreName;
 Eror;
end;

end;

////////////////////////////////////////////////////////////////////////////////
////// /////////////////////////////////////////////////////

function tScript.AddIntParametre(ParametreName:string;ParametreValue:integer):integer;
begin
//   
ScriptLength:=ScriptLength+1;
SetLength(ScriptParametreArray,ScriptLength);
//     
ScriptParametreArray[ScriptLength-1].Name:=ParametreName;
ScriptParametreArray[ScriptLength-1].ParametreType:=INT;
ScriptParametreArray[ScriptLength-1].Int:=ParametreValue;

AddIntParametre:=ScriptLength;

end;

function tScript.AddFloatParametre(ParametreName:string;ParametreValue:real):integer;
begin
//   
ScriptLength:=ScriptLength+1;
SetLength(ScriptParametreArray,ScriptLength);
//     
ScriptParametreArray[ScriptLength-1].Name:=ParametreName;
ScriptParametreArray[ScriptLength-1].ParametreType:=FLOAT;
ScriptParametreArray[ScriptLength-1].Float:=ParametreValue;

AddFloatParametre:=ScriptLength;

end;

function tScript.AddStrParametre(ParametreName:string;ParametreValue:string):integer;
begin
//   
ScriptLength:=ScriptLength+1;
SetLength(ScriptParametreArray,ScriptLength);
//     
ScriptParametreArray[ScriptLength-1].Name:=ParametreName;
ScriptParametreArray[ScriptLength-1].ParametreType:=STRNG;
ScriptParametreArray[ScriptLength-1].Str:=ParametreValue;

AddStrParametre:=ScriptLength-1;

end;

function tScript.AddBolParametre(ParametreName:string;ParametreValue:boolean):integer;
begin
//   
ScriptLength:=ScriptLength+1;
SetLength(ScriptParametreArray,ScriptLength);
//     
ScriptParametreArray[ScriptLength-1].Name:=ParametreName;
ScriptParametreArray[ScriptLength-1].ParametreType:=BOL;
ScriptParametreArray[ScriptLength-1].Bol:=ParametreValue;

AddBolParametre:=ScriptLength;

end;

////////////////////////////////////////////////////////////////////////////////
////// /////////////////////////////////////////////////////////////

procedure tScript.Eror;
var DF:textfile;
begin
//    
//      
LOG_AddMessage(0,PChar('   '+ScriptFile));
Assignfile(DF,'ScriptEror.txt');
Rewrite(DF);
Writeln(DF,ErorName);
CloseFile(DF);
//  
OE_Quit;

end;

end.
