program audio_puzzle;

{$R ico.res}

uses
  Omega, OmegaPNG,
  u_Init in 'u_Init.pas',
  u_Game in 'u_Game.pas',
  u_Menu in 'u_Menu.pas',
  Fmod in 'fmod\Fmod.pas',
  FmodTypes in 'fmod\FmodTypes.pas';

procedure Main;
  begin
    case Scene of
      sMenu : Menu_Process;
      sGame : Game_Process;
      sDone : Done_Process;
      sSele : Sele_Process;
      sAbout: About_Process;
      sDif  : Dif_Process;
      sLogo : Logo_Process;
    end;
  end;

  procedure Init;
  begin
    FSOUND_Init(44100, 32, 0);
    FSOUND_SetSFXMasterVolume(100);
    Scene := sLogo;
    AllInit;
  end;

  procedure Paint;
  begin
    case Scene of
      sMenu : Menu_Paint;
      sGame : Game_Paint;
      sDone : Done_Paint;
      sSele : Sele_Paint;
      sAbout: About_Paint;
      sDif  : Dif_Paint;
      sLogo : Logo_Paint;
    end;
  end;

  procedure Exit;
  begin
    FSOUND_Close();
  end;

  begin
    LoadOMEGA('Omega.dll');
    Main_Timer := Timer_Create (@Main, 5);
    OE_REGPROCEDURE(SYS_DRAW, @Paint);
    OE_REGPROCEDURE(SYS_QUIT, @EXIT);
    OE_REGPROCEDURE(SYS_INIT, @INIT);
    OE_SetScreenOptions(400, 400, 32, 0, FALSE, FALSE);
    OE_ShowCursor(FALSE);
    OE_INIT;
  end.
