///////////////////////////////////////////////////////////////////////
// Copyright (C) Andru 2007                                          //
// mail: dr.andru@gmail.com                                          //
// site: http://andru.2x4.ru                                         //
//                                                                   //
// OMEGA Engine is free software.                                    //
//                                                                   //
// You may redistribute it and/or modify it under the terms of the   //
// GNU General Public License, as published by the Free Software     //
// Foundation; either version 2 of the License, or (at your option)  //
// any later version.                                                //
//                                                                   //
// this module is distributed in the hope that it will be useful,    //
// but WITHOUT ANY WARRANTY; without even the implied warranty of    //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.              //
// See the GNU General Public License for more details.              //
//                                                                   //
// You should have received a copy of the GNU General Public License //
// along with this module.  If not, write to:                        //
// 	The Free Software Foundation, Inc.,                              //
// 	51 Franklin Street, Fifth Floor                                  //
// 	Boston, MA  02110-1301, USA.                                     //
///////////////////////////////////////////////////////////////////////
unit ENGINE_CONST;

{$I DEFINES.pas}

interface

const
  OE_VERSION    = '1.15 OGL';
  wnd_ClassName = 'OMEGA Engine';

//------------------------               ------------------------//
{$IFDEF RUS}
  TEXLOAD = '[ ] ';
  FNTLOAD = '[ ] ';
  SNDLOAD = '[ ] ';
  MSKLOAD = '[ ] ';
{$ELSE}
  TEXLOAD = '[Loading texture] ';
  FNTLOAD = '[Loading font] ';
  SNDLOAD = '[Loading sound] ';
  MSKLOAD = '[Loading mask] ';
{$ENDIF}

//-------------------------------       --------------------------------//
{$IFDEF RUS}
  FROM_MEMORY = '  ';
{$ELSE}
  FROM_MEMORY = 'memory stream';
{$ENDIF}

//-------------------------------       --------------------------------//
{$IFDEF RUS}
//**  **//
  // 
  ERR_SAFE_BOOT                = 'Windows    !    .';
  ERR_QUIT                     = '     !';

  // 
  ERR_CANT_REG_WINDOW          = '   !';
  ERR_CANT_UNREG_WINDOW        = '   !';
  ERR_CANT_CREATE_WINDOW       = '  !';
  ERR_CANT_DESTROY_WINDOW      = '  !';
  ERR_CANT_DC                  = '   !';
  ERR_CANT_RELEASE_DC          = '   !';

  // 
  ERR_CANT_FULLSCREEN          = '    !';
  ERR_CANT_RESTORE_OLDSETTINGS = '   !';

  // OpenGL
  ERR_CANT_GLCONTEXTC          = '    OpenGL!';
  ERR_CANT_GLCONTEXTA          = '    OpenGL!';
  ERR_CANT_GLCONTEXTR          = '    OpenGL!';
  ERR_CANT_GLCONTEXTD          = '    OpenGL!';
  ERR_CANT_BGRA                = '     GL_BGRA!';
  ERR_SOFTWARE                 = '  3D-!       ,   .';
  ERR_UNVALID_OPENGL           = '  OpenGL 1.2!       OpenGL API.';

  // 
  ERR_CANT_FONT_LOAD           = '  : ';

  // 
  ERR_CANT_TEXLOAD             = '  : ';
  ERR_CANT_LOAD_MASK           = '  : ';
  ERR_TEXBIG_RESIZE            = '        .' +
                                 '      ';

  // 
  ERR_SND_CANT_LOAD            = '   DirectSound: "DSound.dll"!';
  ERR_SND_CANT_COOPERATIVE     = '      DirectSound!';
  ERR_SND_NOT_WAVE             = '    ".wav"';
  ERR_SND_CANT_FIND_WAVE_DATA  = '   WAVE  : ';

  // 
  ERR_DSHOW_INIT               = '  DirectShow';

  // 
  ERR_CANT_FIND_FILE           = '  : ';
  ERR_DATA_CORRUPTED           = ' : ';
  ERR_DATA_UNSUPPORTED         = '  : ';
  ERR_CANT_FIND_MEMORY         = '   "" !   ';
  ERR_UNKNOWN_COMMAND          = ' -  ';
{$ELSE}
//**  **//
  // 
  ERR_SAFE_BOOT                = 'Windows works in safe mode! Reboot, and try again.';
  ERR_QUIT                     = 'Unable to free memory from loaded resources!';

  // 
  ERR_CANT_REG_WINDOW          = 'Unable to register the window class!';
  ERR_CANT_UNREG_WINDOW        = 'Unable to unregister the window class!';
  ERR_CANT_CREATE_WINDOW       = 'Unable to create the window!';
  ERR_CANT_DESTROY_WINDOW      = 'Unable to destroy the window!';
  ERR_CANT_DC                  = 'Unable to get a device context!';
  ERR_CANT_RELEASE_DC          = 'Unable to release device context!';

  // 
  ERR_CANT_FULLSCREEN          = 'Unable to switch to fullscreen!';
  ERR_CANT_RESTORE_OLDSETTINGS = 'Unable to restore old settings!';

  // OpenGL
  ERR_CANT_GLCONTEXTC          = 'Unable to create an OpenGL rendering context!';
  ERR_CANT_GLCONTEXTA          = 'Unable to activate OpenGL rendering context!';
  ERR_CANT_GLCONTEXTR          = 'Unable to diactivate OpenGL rendering context!';
  ERR_CANT_GLCONTEXTD          = 'Unable to destroy OpenGL rendering context!';
  ERR_CANT_BGRA                = 'Videocard doesn''t support GL_BGRA texture format!';
  ERR_SOFTWARE                 = 'Unable to find 3D-accelerator! Application run in software-mode, it''s very slow.';
  ERR_UNVALID_OPENGL           = 'Unable to find OpenGL 1.2! Maby videocard or driver doesn''t support OpenGL API.';

  // 
  ERR_CANT_FONT_LOAD           = 'Unable to load font: ';

  // 
  ERR_CANT_TEXLOAD             = 'Unable to load texture: ';
  ERR_CANT_LOAD_MASK           = 'Unable to load mask: ';
  ERR_TEXBIG_RESIZE            = 'Unable to load texture with greater size tht can support your videocard. Texture will be scaled to nearest supported size: ';

  // 
  ERR_SND_CANT_LOAD            = 'Unable to load DirectSound library: "DSound.dll"!';
  ERR_SND_CANT_COOPERATIVE     = 'Unable to set cooperative level for DirectSound!';
  ERR_SND_NOT_WAVE             = ' is not a format of ".wav"';
  ERR_SND_CANT_FIND_WAVE_DATA  = 'Unable to find WAVE-data in file: ';

  // 
  ERR_DSHOW_INIT               = 'Unable to initilize DirectShow';

  // 
  ERR_CANT_FIND_FILE           = 'Unable to find a file: ';
  ERR_DATA_CORRUPTED           = 'Data is corrupted: ';
  ERR_DATA_UNSUPPORTED         = 'Unsupported data format: ';
  ERR_CANT_FIND_MEMORY         = 'Address have a "zero" pointer! Unable to load data';
  ERR_UNKNOWN_COMMAND          = ' - unknown command';
{$ENDIF}

//-------------------------- L O G -          -----------------------//
//**  **//
{$IFDEF RUS}
  LOG_OMEGA_START         = ' ';
  LOG_OMEGA_EXIT          = ' ...';

  LOG_ENGINE              = ': ';
  LOG_APP                 = ': ';
  LOG_CONSOLE             = ': ';
  LOG_ERROR               = ': ';
  LOG_WARNING             = ': ';

  //
  LOG_CREATING_WINDOW     = '  ';
  LOG_SET_PIXEL_FORMAT    = '   ';
  LOG_SET_SCREEN_MODE     = '    : ';

  //Hardware
  LOG_CPU                 = ': ';
  LOG_TOTAL_RAM           = ' : ';
  LOG_VIDEOCARD           = ': ';

  //OpenGL
  LOG_INIT_OPENGL         = '  OpenGL';

  //
  LOG_LOADING_TEXTURE     = '  : ';
  LOG_LOADING_MASK        = '  : ';
  LOG_FREE_TEXTURE        = ' ... ';

  // 
  LOG_LOADING_FONT        = '  : ';
  LOG_FREE_FONT           = '  ';

  //
  LOG_SND_SUCCESSFUL      = '  DirectSound';
  LOG_SND_SUCCESSFUL2     = '   DirectSound';
  LOG_SND_LOAD_SUCCESSFUL = '   : ';
  LOG_SND_FREE_SOUND      = '  ';

  //
  LOG_MEDIA_SUCCESSFUL    = '  DirectShow';
  LOG_MEDIA_SUCCESSFUL2   = '   DirectShow';

  //
  LOG_FREE_TIMERS         = '  ';
  LOG_FREE_CAMERAS        = '  2D ';
  LOG_FREE_FONTS          = '  ';
  LOG_FREE_TEXTURES       = '  ';
  LOG_FREE_MASK           = '  ';
  LOG_FREE_SOUNDS         = '  ';
  LOG_AVERAGE_FPS         = ' FPS: ';
{$ELSE}
//**  **//
  LOG_OMEGA_START         = 'Start';
  LOG_OMEGA_EXIT          = 'Shutdown...';

  LOG_ENGINE              = 'engine: ';
  LOG_APP                 = 'application: ';
  LOG_CONSOLE             = 'console: ';
  LOG_ERROR               = 'error: ';
  LOG_WARNING             = 'warning: ';

  //
  LOG_CREATING_WINDOW     = 'Successful creating of window: ';
  LOG_SET_PIXEL_FORMAT    = 'Successful setting of pixels format';
  LOG_SET_SCREEN_MODE     = 'Successful changing of screen settings: ';

  //Hardware
  LOG_CPU                 = 'CPU: ';
  LOG_TOTAL_RAM           = 'Total RAM: ';
  LOG_VIDEOCARD           = 'Videocard: ';

  //OpenGL
  LOG_INIT_OPENGL         = 'Successful initializing of OpenGL';

  //
  LOG_LOADING_TEXTURE     = 'Successful loading of texture: ';
  LOG_LOADING_MASK        = 'Successful loading of mask: ';
  LOG_FREE_TEXTURE        = 'Freeing texture... successful';

  // 
  LOG_LOADING_FONT        = 'Successful loading of font: ';
  LOG_FREE_FONT           = 'Successful freeing of font';

  //
  LOG_SND_SUCCESSFUL      = 'Successful initializing of DirectSound';
  LOG_SND_SUCCESSFUL2     = 'Successful shutdown of DirectSound';
  LOG_SND_LOAD_SUCCESSFUL = 'Successful loading of sound from: ';
  LOG_SND_FREE_SOUND      = 'Successful freeing of sound';

  //
  LOG_MEDIA_SUCCESSFUL    = 'Successful initializing of DirectShow';
  LOG_MEDIA_SUCCESSFUL2   = 'Successful shutdown of DirectShow';

  //
  LOG_FREE_TIMERS         = 'Successful stopping of timers';
  LOG_FREE_CAMERAS        = 'Successful destroying of 2D cameras';
  LOG_FREE_FONTS          = 'Successful freeing of fonts';
  LOG_FREE_TEXTURES       = 'Successful freeing of textures';
  LOG_FREE_MASK           = 'Successful freeing of mask';
  LOG_FREE_SOUNDS         = 'Successful freeing of sounds';
  LOG_AVERAGE_FPS         = 'Average FPS: ';
{$ENDIF}

//----------------------------------------------------------------------------//
                                 IMPLEMENTATION
//----------------------------------------------------------------------------//

end.
