unit u_Game;

interface
uses
  Omega, Fmod, FmodTypes, Classes, SysUtils;

type
  TScene = ( sGame, sMenu, sSele, sErro, sDone, sAbout, sDif, sLogo );

type
  TNote = record
    PlayMin, PlayMax: Single;
    Number: Integer;
    Use: Boolean;
  end;

type
  TPart = record
    Texture: PTexture;
    Frame, Frame2, Orig: Integer;
    X, Y: Single;
    Note: TNote;
    Rect: OERect;
    Play: Boolean;
  end;

type
  TMove = record
    X, Y: Single;
    Frame, I, J: Integer;
    Enable: Boolean;
  end;

type
  TSelFile = record
    Rect: OERect;
    Dir: String;
    DirF: String;
    WDir, TextX: Single;
    Enable: Boolean;
  end;

var
  Font: PFont2D;
  FileList: TStringList;
  DirList: TStringList;
  SelFiles: array of TSelFile;
  TSelY, TSelMinY, TSelMaxY: Integer;
  TselCount: Integer;
  ListRect: OERect;
  Lengthh, LengthPart, LengthPart2: Single;
  Parts: array [0..7, 0..7] of TPart;
  TempPart: TPart;
  Notes: array [0..64] of TNote;
  Scene: TScene;
  NowPart, Test, Test2, NowPart2, Count, CountWin,
  CountParts, CountPlay, CountNext, PartsWidht, Dif, Black_Alpha: Integer;
  Panel, Blocks, Blocks2, Select, Select2, Done, Back2: PTexture;
  Play, Play2: Boolean;
  Move: TMove;
  Main_Timer: POTimer;
  procedure Game_Process;
  procedure Done_Process;
  procedure Sele_Process;
  procedure Game_Paint;
  procedure Done_Paint;
  procedure Sele_Paint;
  procedure NextPlay;
  procedure Clear;
  function Text_GetWidth( Font: PFont2D; Text: PChar; Scale: Single; Step: Single ): Single;

implementation
uses
  u_Init, u_Menu;

procedure Clear;
var
i, j: Integer;
begin
  for i := 0 to CountParts do
  for j := 0 to CountParts do
  begin
    Parts[i,j].Play := False;
  end;
end;

function Text_GetWidth( Font: PFont2D; Text: PChar; Scale: Single; Step: Single ): Single;
var
  i: integer;
begin
  Result := 0;
  for i := 0 to Length( Text ) - 1 do
  Result := Result + Font^.Sizes[ Byte( Text[ i ] ) ].Width * Scale + Step;
end;

procedure Sele_Process;
var
i, j: integer;
begin
  if Black_Alpha > 0 then Black_Alpha := Black_Alpha - 5;
  if Key_Press( K_SPACE ) then OE_GETFPS;
  if Key_Press( K_ESCAPE ) then
  begin
    FSOUND_StopSound(0);
    Scene := sMenu;
  end;
  if TselCount > 21 then
  begin
    if SelFiles[1].Rect.Y < 28 + 19 then
    begin
      if Mouse_WheelUp then TSelY := TSelY + 5;
    end;

    if SelFiles[TselCount-1].Rect.Y > 381 - 28 then
    begin
      if Mouse_WheelDown then TSelY := TSelY - 5;
    end;
  end;

  for i := 0 to TselCount - 1 do SelFiles[i].Rect.Y := TSelY + (19 * i);
end;

procedure Sele_Paint;
var
i, j, l, r: integer;
begin
  ATile_Draw( Back, -50, -50, 100, 100, 5, 5, 2 );
  for i := 0 to TselCount - 1 do
  begin
    if (SelFiles[i].Rect.Y < 400) and (SelFiles[i].Rect.Y > 0) then Text_Draw( Font, 27-SelFiles[i].TextX, SelFiles[i].Rect.Y+2, PChar(String(SelFiles[i].DirF)), 0.55, -7 );
    if Col_PointInAABB( Mouse_X, Mouse_Y, @SelFiles[i].Rect ) = False then
    begin
      if SelFiles[i].TextX > 0 then SelFiles[i].TextX := SelFiles[i].TextX - 0.3;
      if SelFiles[i].TextX < 0 then SelFiles[i].TextX := 0;
    end;
    if Col_PointInAABB( Mouse_X, Mouse_Y, @SelFiles[i].Rect ) then
    begin
      if Col_PointInAABB( Mouse_X, Mouse_Y, @ListRect ) then
      begin
        if SelFiles[i].WDir > 338 then
        begin
          if (SelFiles[i].WDir - 338) > SelFiles[i].TextX
          then SelFiles[i].TextX  := SelFiles[i].TextX + 0.05;
        end;
        Pr2D_TRect( @SelFiles[i].Rect, $FFFFFF, 100, 1 );
        if Mouse_Click( M_LBUTTON ) then
        begin
          Music := FSOUND_Sample_Load(1,PChar(SelFiles[i].Dir),1,1);
          case Dif of
            1 : SetNotes2;
            2 : SetNotes;
          end;  
          Scene := sGame;
        end;
      end;
    end;
  end;
  SSprite_Draw( List, 0, 0, 400, 400 );
  SSprite_Draw( Cursor, Mouse_X, Mouse_Y, 50, 50 );
  if Black_Alpha > 0 then Pr2D_Rect( 0, 0, 400, 400, $000000, Black_Alpha, 1 );
end;

procedure NextPlay;
begin
  if Play2 then
  begin
    Count := Count + 1;
    Test := Test + 1;
    if Test = CountNext then
    begin
      Test2 := Test2 + 1;
      Test := 0;
    end;
    FSOUND_PlaySound(0,Music);
    FSOUND_SetCurrentPosition(0,Round(Parts[Test,Test2].Note.PlayMin));
    FSOUND_Sample_SetLoopPoints(Music,Round(Parts[Test,Test2].Note.PlayMin),Round(Parts[Test,Test2].Note.PlayMax));
  end;
end;

procedure Done_Process;
begin
  Button_Process( @BMenu );
  if Mouse_Click( M_LBUTTON ) then
  begin
    if Col_PointInAABB( Mouse_X, Mouse_Y, @BMenu.Rect ) then Scene := sMenu;
  end;
end;

procedure Done_Paint;
begin
  ATile_Draw( Back, -50, -50, 100, 100, 5, 5, 1 );
  SSprite_Draw( Done, 40, 82, 320, 150 );
  Button_Paint( @BMenu );
  SSprite_Draw( Cursor, Mouse_X, Mouse_Y, 50, 50 );
end;

procedure Game_Process;
var
i, j: Integer;
begin
  if Key_Press( K_ESCAPE ) then
  begin
    FSOUND_StopSound(0);
    Parts[Move.I,Move.J].Frame := Parts[Move.I,Move.J].Frame2;
    Move.Enable := False;
    Play2 := False;
    Scene := sMenu;
  end;
  if Key_Press( K_SPACE ) then
  begin
    Clear;
    if Play2 then
    begin
      FSOUND_StopSound(0);
      Play2 := False;
    end
    else
    begin
      Count := 0;
      Play2 := True;
      Test := -1;
      Test2 := 0;
      NextPlay;
    end;
  end;
  for i := 0 to CountParts do
  for j := 0 to CountParts do
  begin
    if Omega.Col_PointInAABB( Mouse_X, Mouse_Y, @Parts[i,j].Rect ) then
    begin
      if Play2 = False then
      begin
        if Mouse_Click( M_RBUTTON ) then
        begin
          if Move.Enable = False then
          begin
            Clear;
            FSOUND_SetSFXMasterVolume(100);
            FSOUND_PlaySound(0,Music);
            FSOUND_SetCurrentPosition(0,Round(Parts[i,j].Note.PlayMin));
            FSOUND_Sample_SetLoopPoints(Music,Round(Parts[i,j].Note.PlayMin),Round(Parts[i,j].Note.PlayMax));
            Parts[i,j].Play := True;
          end;
        end;
        if Mouse_Click( M_LBUTTON ) then
        begin
          Clear;
          FSOUND_StopSound(0);
          case Dif of
            1 :
            begin
              Move.X := Mouse_X - Parts[i,j].Rect.X + 8;
              Move.Y := Mouse_Y - Parts[i,j].Rect.Y + 6;
            end;
            2 :
            begin
              Move.X := Mouse_X - Parts[i,j].Rect.X + 4;
              Move.Y := Mouse_Y - Parts[i,j].Rect.Y + 2;
            end;
          end;
          Move.I := i;
          Move.J := j;
          Move.Frame := Parts[i,j].Frame;
          Parts[i,j].Frame := 8;
          Move.Enable := true;
        end;
      end;
    end;
  end;
  if Mouse_Press( M_LBUTTON ) then
  begin
    Clear;
    if Move.Enable then
    begin
      for i := 0 to CountParts do
      for j := 0 to CountParts do
      begin
        if Col_PointInAABB( Mouse_X, Mouse_Y, @Parts[i,j].Rect ) = False then
        begin
          Parts[Move.I,Move.J].Frame := Parts[Move.I,Move.J].Frame2;
          Move.Enable := False;
        end;
        if Col_PointInAABB( Mouse_X, Mouse_Y, @Parts[i,j].Rect ) then
        begin
          TempPart.Frame := Parts[i,j].Frame2;
          TempPart.Frame2 := Parts[i,j].Frame2;
          TempPart.Note:= Parts[i,j].Note;
          Parts[i,j].Frame := Parts[Move.I,Move.J].Frame2;
          Parts[i,j].Frame2 := Parts[Move.I,Move.J].Frame2;
          Parts[i,j].Note := Parts[Move.I,Move.J].Note;
          Parts[Move.I,Move.J].Frame := TempPart.Frame2;
          Parts[Move.I,Move.J].Frame2 := TempPart.Frame2;
          Parts[Move.I,Move.J].Note := TempPart.Note;
          Move.Enable := False;
        end;
      end;
    end;
  end;
  if Play2 then
  begin
    for i := 0 to CountParts do
    for j := 0 to CountParts do
    begin
      if Col_PointInAABB( Mouse_X, Mouse_Y, @Parts[i,j].Rect ) then
      begin
        Text_Draw( Font, Parts[i,j].X, Parts[i,j].Y, PChar( U_IntToStr( Parts[i,j].Note.Number ) ), 1, -15 );
        if Mouse_Click( M_LBUTTON ) then
        begin
          Test := i;
          Test2 := j;
          FSOUND_PlaySound(0,Music);
          FSOUND_SetCurrentPosition(0,Round(Parts[Test,Test2].Note.PlayMin));
          FSOUND_Sample_SetLoopPoints(Music,Round(Parts[Test,Test2].Note.PlayMin),Round(Parts[Test,Test2].Note.PlayMax));
          Count := Parts[i,j].Orig;
        end;
      end;
    end;
    if FSOUND_IsPlaying(0) = False then
    begin
      if Count < CountPlay then NextPlay else Play2 := False;
    end;
  end;
  if FSOUND_IsPlaying(0) = False then Clear;
  CountWin := 0;
  for i := 0 to CountParts do
  for j := 0 to CountParts do
  begin
    if Parts[i,j].Orig = Parts[i,j].Note.Number
    then CountWin := CountWin + 1;
  end;
  if CountWin = CountPlay then
  begin
    FSOUND_StopSound(0);
    Scene := sDone;
  end;
end;

procedure Game_Paint;
var
i, j: Integer;
begin
  ATile_Draw( Back, -50, -50, 100, 100, 5, 5, 1 );
  SSprite_Draw( Panel, 40, 40, 320, 320 );
  for i := 0 to CountParts do
  for j := 0 to CountParts do
  begin
    ASprite_Draw( Parts[i,j].Texture, Parts[i,j].X, Parts[i,j].Y, PartsWidht, PartsWidht, Parts[i,j].Frame  );
    if Parts[i,j].Play then
    begin
      case Dif of
        1 : SSprite_Draw( Select2, Parts[i,j].Rect.X-8,
            Parts[i,j].Rect.Y-6, PartsWidht, PartsWidht, 100 );
        2 : SSprite_Draw( Select, Parts[i,j].Rect.X-4,
            Parts[i,j].Rect.Y-2, PartsWidht, PartsWidht, 100 );
      end;
    end;
  end;
  if Play2 then
  begin
    case Dif of
      1 : SSprite_Draw( Select2, Parts[Test,Test2].Rect.X-8,
          Parts[Test,Test2].Rect.Y-6, PartsWidht, PartsWidht, 100 );
      2 : SSprite_Draw( Select, Parts[Test,Test2].Rect.X-4,
          Parts[Test,Test2].Rect.Y-2, PartsWidht, PartsWidht, 100 );
    end;
  end;
  case Dif of
    1 : if Move.Enable then ASprite_Draw( Blocks2, Mouse_X - Move.X, Mouse_Y - Move.Y, PartsWidht, PartsWidht, Move.Frame );
    2 : if Move.Enable then ASprite_Draw( Blocks, Mouse_X - Move.X, Mouse_Y - Move.Y, PartsWidht, PartsWidht, Move.Frame );
  end;
  SSprite_Draw( Cursor, Mouse_X, Mouse_Y, 50, 50 );
end;

end.

