unit u_Init;

interface
uses
  Omega, OmegaPNG, SysUtils, Fmod, FmodTypes, FolderActions, Windows, Classes;

var
  DirFiles: String;
  FPS, Test: Integer;
  procedure AllInit;
  procedure SetNote;
  procedure SetNote2;
  procedure SetNotes;
  procedure SetNotes2;

implementation
uses
  u_Game, u_Menu;

procedure SetNotes;
var
i, j, r: integer;
begin
  FSOUND_SetSFXMasterVolume(100);
  Lengthh := FSOUND_Sample_GetLength(Music);
  LengthPart := Lengthh / 64;
  LengthPart2 := 0;
  Test := 0;
  for i := 1 to 64 do
  begin
    Notes[i].PlayMin := LengthPart2;
    Notes[i].PlayMax := LengthPart2 + LengthPart;
    Notes[i].Use := false;
    Notes[i].Number := i;
    LengthPart2 := LengthPart2 + LengthPart;
  end;
  for j := 0 to 7 do
  for i := 0 to 7 do
  begin
    Parts[i,j].Texture := Blocks;
    Parts[i,j].X := i * 37 + 50;
    Parts[i,j].Y := j * 37 + 50;
    Parts[i,j].Rect.X := Parts[i,j].X + 4;
    Parts[i,j].Rect.Y := Parts[i,j].Y + 2;
    Parts[i,j].Rect.Width := 33;
    Parts[i,j].Rect.Height := 33;
    Randomize;
    Parts[i,j].Frame := Random( 7 ) + 1;
    Parts[i,j].Frame2 := Parts[i,j].Frame;
    r := Test + 1;
    Parts[i,j].Note.PlayMin := Notes[r].PlayMin;
    Parts[i,j].Note.PlayMax := Notes[r].PlayMax;
    Parts[i,j].Note.Number := Notes[r].Number;
    Parts[i,j].Orig := Notes[r].Number;
    Test := Test + 1;
  end;
  SetNote;
  CountParts := 7;
  CountPlay := 64;
  CountNext := 8;
  PartsWidht := 40;
  Dif := 2;
end;

procedure SetNotes2;
var
i, j, r: integer;
begin
  FSOUND_SetSFXMasterVolume(100);
  Lengthh := FSOUND_Sample_GetLength(Music);
  LengthPart := Lengthh / 16;
  LengthPart2 := 0;
  Test := 0;
  for i := 1 to 16 do
  begin
    Notes[i].PlayMin := LengthPart2;
    Notes[i].PlayMax := LengthPart2 + LengthPart;
    Notes[i].Use := false;
    Notes[i].Number := i;
    LengthPart2 := LengthPart2 + LengthPart;
  end;
  for j := 0 to 3 do
  for i := 0 to 3 do
  begin
    Parts[i,j].Texture := Blocks2;
    Parts[i,j].X := i * 72 + 52;
    Parts[i,j].Y := j * 72 + 52;
    Parts[i,j].Rect.X := Parts[i,j].X + 8;
    Parts[i,j].Rect.Y := Parts[i,j].Y + 6;
    Parts[i,j].Rect.Width := 64;
    Parts[i,j].Rect.Height := 64;
    Randomize;
    Parts[i,j].Frame := Random( 7 ) + 1;
    Parts[i,j].Frame2 := Parts[i,j].Frame;
    r := Test + 1;
    Parts[i,j].Note.PlayMin := Notes[r].PlayMin;
    Parts[i,j].Note.PlayMax := Notes[r].PlayMax;
    Parts[i,j].Note.Number := Notes[r].Number;
    Parts[i,j].Orig := Notes[r].Number;
    Test := Test + 1;
  end;
  SetNote2;
  CountParts := 3;
  CountPlay := 16;
  CountNext := 4;
  PartsWidht := 80;
  Dif := 1;
end;

procedure SetNote;
var
r, i, j, k, l: Integer;
begin
  for r := 0 to 80 do
  begin
    Randomize;
    i := random( 8 );
    j := random( 8 );
    k := random( 8 );
    l := random( 8 );
    if (i <> k) and (j <> l) then
    begin
      Notes[0] := Parts[i,j].Note;
      Parts[i,j].Note := Parts[k,l].Note;
      Parts[k,l].Note := Notes[0];
    end;
  end;
end;

procedure SetNote2;
var
r, i, j, k, l: Integer;
begin
  for r := 0 to 80 do
  begin
    Randomize;
    i := random( 4 );
    j := random( 4 );
    k := random( 4 );
    l := random( 4 );
    if (i <> k) and (j <> l) then
    begin
      Notes[0] := Parts[i,j].Note;
      Parts[i,j].Note := Parts[k,l].Note;
      Parts[k,l].Note := Notes[0];
    end;
  end;
end;

procedure AllInit;
var
i, j, r: Integer;
m: single;
begin
  INI_LoadFromFile( 'config.ini' );
  DirFiles := INI_ReadKeyStr( 'Options', 'Dir' );
  Back := Tex_LoadPNGFromFile( 'data\back.png', -1, TEX_DEFAULT_2D );
  Title := Tex_LoadPNGFromFile( 'data\title.png', -1, TEX_DEFAULT_2D );
  Cursor := Tex_LoadPNGFromFile( 'data\cursor.png', -1, TEX_DEFAULT_2D );
  Panel := Tex_LoadPNGFromFile( 'data\panels\game.png', -1, TEX_DEFAULT_2D );
  Blocks := Tex_LoadPNGFromFile( 'data\notes\small_notes.png', -1, TEX_DEFAULT_2D );
  Select := Tex_LoadPNGFromFile( 'data\notes\small_select.png', -1, TEX_DEFAULT_2D );
  Select2 := Tex_LoadPNGFromFile( 'data\notes\big_select.png', -1, TEX_DEFAULT_2D );
  Done := Tex_LoadPNGFromFile( 'data\panels\done.png', -1, TEX_DEFAULT_2D );
  About := Tex_LoadPNGFromFile( 'data\panels\about.png', -1, TEX_DEFAULT_2D );
  Blocks2 := Tex_LoadPNGFromFile( 'data\notes\big_notes.png', -1, TEX_DEFAULT_2D );
  Logo := Tex_LoadPNGFromFile( 'data\logo.png', -1, TEX_DEFAULT_2D );
  Tex_SetFramesSize( Blocks, 40, 40 );
  Tex_SetFramesSize( Back, 100, 100 );
  Tex_SetFramesSize( Blocks2, 80, 80 );
  List := Tex_LoadPNGFromFile( 'data\panels\list.png', -1, TEX_DEFAULT_2D );
  BStart.Texture := Tex_LoadPNGFromFile( 'data\buttons.png', -1, TEX_DEFAULT_2D );
  BStart.Frame1 := 1;
  BStart.Frame2 := 3;
  BStart.Rect.X := 125;
  BStart.Rect.Y := 200;
  BStart.Rect.Width := 150;
  BStart.Rect.Height := 50;
  BStart.Visible := True;
  Tex_SetFramesSize( BStart.Texture, 150, 50 );
  BQuit.Texture := BStart.Texture;
  BQuit.Frame1 := 5;
  BQuit.Frame2 := 7;
  BQuit.Rect.X := 125;
  BQuit.Rect.Y := 270;
  BQuit.Rect.Width := 150;
  BQuit.Rect.Height := 50;
  BQuit.Visible := True;
  BMenu.Texture := BStart.Texture;
  BMenu.Frame1 := 9;
  BMenu.Frame2 := 11;
  BMenu.Rect.X := 125;
  BMenu.Rect.Y := 270;
  BMenu.Rect.Width := 150;
  BMenu.Rect.Height := 50;
  BMenu.Visible := True;
  BBack.Texture := BStart.Texture;
  BBack.Frame1 := 10;
  BBack.Frame2 := 12;
  BBack.Rect.X := 125;
  BBack.Rect.Y := 270;
  BBack.Rect.Width := 150;
  BBack.Rect.Height := 50;
  BBack.Visible := True;
  BNorm.Texture := BStart.Texture;
  BNorm.Frame1 := 2;
  BNorm.Frame2 := 4;
  BNorm.Rect.X := 125;
  BNorm.Rect.Y := 130;
  BNorm.Rect.Width := 150;
  BNorm.Rect.Height := 50;
  BNorm.Visible := True;
  BHard.Texture := BStart.Texture;
  BHard.Frame1 := 6;
  BHard.Frame2 := 8;
  BHard.Rect.X := 125;
  BHard.Rect.Y := 220;
  BHard.Rect.Width := 150;
  BHard.Rect.Height := 50;
  BHard.Visible := True;
  OE_SetWndName('Audio Puzzle');
  SetNotes;
  BackX := -50;
  BackY := -50;
  Font := Text_LoadFontFromFile( 'data\font\free.bmp', 'data\font\config.ofi', $000000, TEX_DEFAULT_2D );
  Font.Texture := Tex_LoadPNGFromFile( 'data\font\texture.png', -1, TEX_DEFAULT_2D );
  FileList := TStringList.Create;
  FileList := GetAllFiles('*.mp3',DirFiles);
  DirList := TStringList.Create;
  DirList := GetAllFiles('*.mp3',DirFiles);
  SetLength(SelFiles,FileList.Count);
  TSelY := 30;
  for i := 0 to FileList.Count -1 do
  begin
    SelFiles[i].DirF := FileList.Strings[i];
    SelFiles[i].Dir := DirList.Strings[i];
    SelFiles[i].Rect.X := 29;
    SelFiles[i].Rect.Y := TSelY + 20 * i;
    SelFiles[i].Rect.Width := 341;
    SelFiles[i].Rect.Height := 20;
    SelFiles[i].Enable := True;
    TselCount := TselCount + 1;
  end;
  for i := 0 to TselCount - 1 do
  begin
    SelFiles[i].WDir := Text_GetWidth( Font, PChar(SelFiles[i].DirF), 0.55, -7 );
  end;
  ListRect.X := 30;
  ListRect.Y := 27;
  ListRect.Width := 341;
  ListRect.Height := 342;
  About_Rect.X := 25;
  About_Rect.Y := 75;
  About_Rect.Width := 350;
  About_Rect.Height := 60;
  logo_count := 750;
  logo_alpha := 255;
end;

end.
