unit u_Menu;

interface
uses
  Omega, Fmod, FmodTypes;

type
  PButton = ^TButton;
  TButton = record
    Rect: OERect;
    Texture: PTexture;
    Frame, Frame1, Frame2: Integer;
    Visible: Boolean;
  end;

var
  Music, MenuMus: PFSoundSample;
  FPS: Integer; BackX, BackY: Single;
  Back, Title, Cursor, Help, Error, List, About, Logo: PTexture;
  logo_count, logo_alpha: Single;
  About_Rect: OERECT;
  BStart, BQuit, BMenu, BBack, BNorm, BHard: TButton;
  procedure Menu_Process;
  procedure About_Process;
  procedure Menu_Paint;
  procedure About_Paint;
  procedure Dif_Process;
  procedure Dif_Paint;
  procedure Logo_Process;
  procedure Logo_Paint;
  procedure Button_Process( Button: PButton );
  procedure Button_Paint( Button: PButton );

implementation
uses
  u_Game, u_Init;

procedure Button_Process( Button: PButton );
begin
  if Button.Visible then
  begin
    if Col_PointInAABB( Mouse_X, Mouse_Y, @Button.Rect )
    then Button.Frame := Button.Frame2 else Button.Frame := Button.Frame1;
  end;
end;

procedure Button_Paint( Button: PButton );
begin
  if Button.Visible then
  begin
    ASprite_Draw( Button.Texture, Button.Rect.X, Button.Rect.Y,
    Button.Rect.Width, Button.Rect.Height, Button.Frame, 255, 0 );
  end;
end;

procedure Logo_Process;
var
r: integer;
begin
  logo_count := logo_count - 1;
  if logo_count <= 0 then
  begin
    logo_alpha := logo_alpha - 5;
  end;
  if logo_alpha <= 0 then
  begin
    Scene := sMenu;
    Black_Alpha := 255;
  end;
  if Key_Press( K_SPACE ) then logo_count := 0;
  if Key_Press( K_ENTER ) then logo_count := 0;
  if Key_Press( K_ESCAPE ) then logo_count := 0;
  if Mouse_Press( M_LBUTTON ) then logo_count := 0;
end;

procedure Logo_Paint;
begin
  Pr2D_Rect( 0, 0, 400, 400, $000000, 255, 1 );
  SSprite_Draw( Logo, 0, 0, 400, 400, Round(logo_alpha) );
end;

procedure Menu_Process;
var
i, j: Integer;
begin
  if Black_Alpha > 0 then Black_Alpha := Black_Alpha - 5;
  if Key_Press( K_SPACE ) then OE_GETFPS;
  if Key_Press( K_ESCAPE ) then OE_Quit;
  Button_Process( @BStart );
  Button_Process( @BQuit );
  if Mouse_Click( M_LBUTTON ) then
  begin
    if Col_PointInAABB( Mouse_X, Mouse_Y, @About_Rect ) then Scene := sAbout;
    if Col_PointInAABB( Mouse_X, Mouse_Y, @BStart.Rect ) then
    begin
      SetNote;
      for j := 0 to 7 do
      for i := 0 to 7 do
      begin
        Parts[i,j].Frame := Random( 7 ) + 1;
        Parts[i,j].Frame2 := Parts[i,j].Frame;
      end;
      TSelY := 28;
      TSelMinY := 0;
      TSelMaxY := 20 * (TselCount-1);
      for i := 0 to TselCount - 1 do
      begin
        SelFiles[i].TextX := 0;
      end;
      Scene := sDif;
    end;
    if Col_PointInAABB( Mouse_X, Mouse_Y, @BQuit.Rect ) then OE_Quit;
  end;
end;

procedure Menu_Paint;
var
i: Integer;
begin
  ATile_Draw( Back, -50, -50, 100, 100, 5, 5, 1 );
  SSprite_Draw( Title, 25, 75, 350, 60 );
  Button_Paint( @BStart );
  Button_Paint( @BQuit );
  SSprite_Draw( Cursor, Mouse_X, Mouse_Y, 50, 50 );
  if Black_Alpha > 0 then Pr2D_Rect( 0, 0, 400, 400, $000000, Black_Alpha, 1 );
end;

procedure Dif_Process;
begin
  if Black_Alpha > 0 then Black_Alpha := Black_Alpha - 5;
  if Key_Press( K_SPACE ) then OE_GETFPS;
  if Mouse_Click( M_LBUTTON ) then
  begin
    if Col_PointInAABB( Mouse_X, Mouse_Y, @BNorm.Rect ) then
    begin
      Dif := 1;
      Scene := sSele;
    end;
    if Col_PointInAABB( Mouse_X, Mouse_Y, @BHard.Rect ) then
    begin
      Dif := 2;
      Scene := sSele;
    end;
  end;
  if Key_Press( K_ESCAPE ) then Scene := sMenu;
  Button_Process( @BNorm );
  Button_Process( @BHard );
end;

procedure Dif_Paint;
begin
  ATile_Draw( Back, -50, -50, 100, 100, 5, 5, 1 );
  Button_Paint( @BNorm );
  Button_Paint( @BHard );
  SSprite_Draw( Cursor, Mouse_X, Mouse_Y, 50, 50 );
  if Black_Alpha > 0 then Pr2D_Rect( 0, 0, 400, 400, $000000, Black_Alpha, 1 );
end;

procedure About_Process;
begin
  if Black_Alpha > 0 then Black_Alpha := Black_Alpha - 5;
  if Key_Press( K_SPACE ) then OE_GETFPS;
  if Key_Press( K_ESCAPE ) then Scene := sMenu;
  Button_Process( @BBack );
  if Mouse_Click( M_LBUTTON ) then
  begin
    if Col_PointInAABB( Mouse_X, Mouse_Y, @BBack.Rect ) then Scene := sMenu;
  end;
end;

procedure About_Paint;
begin
  ATile_Draw( Back, -50, -50, 100, 100, 5, 5, 1 );
  SSprite_Draw( About, 40, 82, 320, 150 );
  Button_Paint( @BBack );
  SSprite_Draw( Cursor, Mouse_X, Mouse_Y, 50, 50 );
  if Black_Alpha > 0 then Pr2D_Rect( 0, 0, 400, 400, $000000, Black_Alpha, 1 );
end;

end.

