unit e_music;

interface

uses e_console, e_utils;

type
  TSoundPatterns = class
    patterns : array of integer;
    current  : byte;
    start    : single;
    timer    : single;
    offset   : integer;
    repeat_next : integer;
    repeat_step : integer;
  public
    constructor Create(_number, _offset, _start, _repeats : integer; _begin : integer = 0);
    procedure   Event;                      virtual;
    procedure   Next;                       virtual;
    procedure   Update(count : single);
  end;

  TSPBeat = class(TSoundPatterns)
  public
    procedure   Next;                      override;
  end;

const
  temp = 8400;

var
  sp_beat :  TSoundPatterns;

procedure MusicInitialize;
procedure MusicUpdate(count : single);

implementation

uses e_sound;

procedure MusicInitialize;
var
i : integer;
begin
sp_beat   := TSPBeat.Create(1, 0, 0, 1);
end;

procedure MusicUpdate(count : single);
var
i : integer;
begin
if volume_music <= 0 then exit;

sp_beat.Update(count);
end;

constructor TSoundPatterns.Create;
var
i : integer;
begin
start   := _start * temp / 8;
timer   := temp + 1;
current := 0;
SetLength(patterns, _number + 1);
for i := 0 to high(patterns) do
  patterns[i] := 0;

patterns[0] := _begin;
offset := _offset;
repeat_next := 0;
repeat_step := 9 + _start - _repeats;
end;

procedure TSoundPatterns.Event;
begin
//if offset <> 0 then
if current <> 0 then
  if music[offset + current - 1] <> nil then
    if music[offset + current - 1].loaded then
      music[offset + current - 1].Play
    else
      Console.Write(inttostr(offset + current - 1) + ' not loaded')
  else
    Console.Write(inttostr(offset + current - 1) + ' not created');
    
dec(patterns[current]);
if patterns[current] <= 0 then
  Next;
end;

procedure TSoundPatterns.Next;
begin
current := random(2);
patterns[current] := 1;
end;

procedure TSoundPatterns.Update;
begin
timer := timer + count;
if timer > start + repeat_next / 8 * temp + 4 then
  begin
    Event;
    repeat_next := repeat_next + repeat_step;
  end;

if timer >= temp then
  begin
    timer := 0;
    repeat_next := 0;
  end;
end;

procedure TSPBeat.Next;
begin
current := 1;
patterns[current] := 1;
end;

end.
