unit g_Game;

interface
uses
  HGE,HGEFont,HGESprite,HGEParticle,sysutils,
  g_Types,g_LevelManager,g_cfg,g_Options,
  g_utils,g_gui,g_Hint,g_Loading,g_Map,g_pchar,g_camera,g_Bonus,g_Gun;

procedure World_Create();
procedure World_Init();
procedure World_Update(const delta : single);
procedure World_Draw();
procedure World_Destroy();
implementation
uses
  g_main, Classes;

procedure World_Create();
begin
  Loading.Process('Create world...');
  //Loading.TextPosX := 32;
  //SetPChar( Loading.Text2, ' !    ,    .           .    !');
  //FntMan.WordTransfer(Loading.Fnt,Loading.Text2,320);
  with Game do begin
    Music := _Hge.Stream_Load(Cfg_ReadStr('data\cfg\game.cfg','MUSIC','data\music\Slava - Synthez.mp3'));
    GameplayColorCount := 7;
    GameplayColorAll[0] := $ff000000;
    GameplayColorAll[1] := $ff4444ff;                                          // blue
    GameplayColorAll[2] := $ff44ff44;                                          // green
    GameplayColorAll[3] := $ffff4444;                                          // red
    GameplayColorAll[4] := $ffffff33;                                          // yelow
    GameplayColorAll[5] := $ff33ffff;                                          //   
    GameplayColorAll[6] := $ffff33ff;                                          // violet
    //GameplayColor[7] := $ff000000;
    TexParticle := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\game.cfg','TEXTURE_PARTICLE_BALL','particles.png'));
    Pause := false;
  end;
  Map := TMap.Create;
  ParticleManager := THGEParticleManager.Create;
  //BonusManager := TBonusManager.Create;
  Gun := TGun.Create;
end;

procedure World_Init();
begin
  Loading.Process('Game settings...');
  with Game do begin
    Profile.Init;
  end;
  Loading.Process('Init objects...');
  Ballman.Clear;
  ParticleManager.KillAll;
  //BonusManager.Init;
  Game.Channel.Resume;
  GUI.Hint.Clear;
  GUI.GamePlayHint.Clear;
  GUI.HintLevelName.Clear;
  Gun.Init(398*WndAspect, 312*WndAspect);
  //Loading.Process('  ');
end;

procedure World_Update(const delta : single);
begin
  ParticleManager.Update(delta);
  //BonusManager.Update(delta);
  Map.Update(delta);
  Gun.Update(delta);
  GUI.Hint.Update(delta);
  GUI.GamePlayHint.Update(delta);
  GUI.HintLevelName.Update(delta);
  Profile.Update;
end;

procedure World_Draw();
begin
  //Camera.View;
  //Camera.Reset;
  Map.Render;
  ParticleManager.Render;
  //BonusManager.Render;
  Map.UpLayerRender;
  Gun.Render;
  GUI.Hint.Draw;
end;

procedure World_Destroy();
begin
  Map.Destroy;
  GUI.Hint.Destroy;
  GUI.GamePlayHint.Destroy;
  GUI.HintLevelName.Destroy;
  ParticleManager := nil;
  LevelManager.Destroy;
  //BonusManager.Destroy;
end;

end.
