unit g_Intro;

interface
uses
  HGE,HGEFont,HGESprite,HGEColor,
  g_Types,g_Utils;

type
  TIntro= record
    Tex : ITexture;
    Spr : IHGESprite;
    stime,Delay : single;
    //Scale : single;
  end;

  TIntroManager = record
    Color : THGEColor;
    ItemCount : byte;
    ActiveItem : byte;
    Item : array of TIntro;
  end;

var
  Intro : TIntroManager;

procedure StartIntro;
procedure IntroDraw;
procedure IntroUpdate(const delta : single);
procedure IntroComplite;
implementation
uses
  g_Main;

procedure StartIntro;
var
  i : byte;
  //ScaleX,ScaleY : single;
begin
  game.State := gsIntro;
  Intro.ActiveItem := 0;
  Intro.ItemCount := _HGE.Ini_GetInt('INTRO','SCREENCOUNT',0);
  SetLength(Intro.Item,Intro.ItemCount);
  i := 0;
  while i < Intro.ItemCount do begin
    Intro.Item[i].Tex := _HGE.Texture_Load(_HGE.Ini_GetString('INTRO','TEXTURE'+inttostr(i+1),'intro.tga'));
    Intro.Item[i].Spr := THGESprite.Create(Intro.Item[i].Tex,0,0,Intro.Item[i].Tex.GetWidth,Intro.Item[i].Tex.GetHeight());
    Intro.Item[i].Spr.SetHotSpot(Intro.Item[i].Tex.GetWidth/2,Intro.Item[i].Tex.GetHeight/2);
    //ScaleX := WND_WIDTH/Intro.Item[i].Tex.GetWidth;
    //ScaleY := WND_HEIGHT/Intro.Item[i].Tex.GetHeight;
    //if ScaleX>ScaleY then Intro.Item[i].Scale := ScaleY else Intro.Item[i].Scale := ScaleX;
    Intro.Item[i].Delay := _HGE.Ini_GetInt('INTRO','TIME'+inttostr(i+1),3);
    Intro.Item[i].sTime := 0;
    inc(i);
  end;
  Intro.Color := THGEColor.Create(1,1,1,0);
end;

procedure IntroComplite;
begin
  MainInit;
end;

procedure IntroUpdate;
begin
  if _HGE.Input_GetKeyState($1B) or _HGE.Input_GetKeyState($0D)
  or _HGE.Input_GetKeyState($20) or (Intro.ItemCount = 0) then begin
    if Intro.ActiveItem < Intro.ItemCount-1 then inc(Intro.ActiveItem) else begin
      IntroComplite;
      exit;
    end;
    Intro.Item[Intro.ActiveItem].sTime := 0;
    Intro.Color.A := 0;
  end else begin
    Intro.Item[Intro.ActiveItem].sTime := Intro.Item[Intro.ActiveItem].sTime + delta;
    if Intro.Item[Intro.ActiveItem].sTime < Intro.Item[Intro.ActiveItem].Delay then
      if Intro.Color.A < 1 then Intro.Color.A := Intro.Color.A+0.5*delta else else
    if Intro.ActiveItem < Intro.ItemCount-1 then begin
      if Intro.Color.A > 0 then Intro.Color.A := Intro.Color.A-0.5*delta else begin
        inc(Intro.ActiveItem);
        Intro.Item[Intro.ActiveItem].sTime := 0;
      end;
    end else if Intro.Color.A > 0 then Intro.Color.A := Intro.Color.A-0.5*delta else IntroComplite;
  end;
end;

procedure IntroDraw;
begin
  if Intro.ItemCount > 0 then begin
  _HGE.Gfx_Clear($ffffffff);
    Intro.Item[Intro.ActiveItem].Spr.SetColor(Intro.Color.GetHWColor);
    Intro.Item[Intro.ActiveItem].Spr.SetBlendMode(BLEND_COLORMUL or BLEND_ALPHABLEND);
    Intro.Item[Intro.ActiveItem].Spr.RenderStretch(0,0,WND_WIDTH,WND_HEIGHT);
    //Intro.Item[Intro.ActiveItem].Spr.RenderEx(SCR_CENTER_W,SCR_CENTER_H,0,
    //                             Intro.Item[Intro.ActiveItem].Scale, Intro.Item[Intro.ActiveItem].Scale);
  end;
end;

end.
