unit g_LevelManager;

interface
uses
  HGE,
  g_Utils,g_cfg;

type
  TLevelType = (ltTime,ltWiner);
  TLevelManager = class
  public
    LevelCount,LevelCurrent : byte;
    Levels : array of string;
    LevelTime,LevelDelay,
    LevelToTimeTime,LevelToTimeDelay,
    LevelWinerTime,LevelWinerDelay : single;
    Day,Hour,Minute,Second : byte;
    PrepareTime,PrepareDelay : single;                                         //      
    isPlaying : boolean;
    Finish : boolean;
    _Type : TLevelType;
  public
    constructor Create;
    destructor Destroy;
    procedure NewGame(__Type : TLevelType);
    procedure Update(const delta : single);
    procedure LevelEnd;
    procedure NextLevel;
    procedure GameOver;
  end;

implementation
uses
  g_Game,g_Types,g_Camera,g_top,g_Options,g_gun;

constructor TLevelManager.Create;
var
  f : TextFile;
begin
  inherited Create;
  Finish := false;
  PrepareDelay := Cfg_ReadInt('data\cfg\map.cfg','LEVEL_CAMERA_MOVE_DELAY',2);
  LevelToTimeDelay := Cfg_ReadInt('data\cfg\map.cfg','LEVEL_GAME_TO_TIME_DELAY',300);
  LevelWinerDelay := Cfg_ReadInt('data\cfg\map.cfg','LEVEL_GAME_TO_WINER_DELAY',30);
  World_Create();
  AssignFile(f,'data\cfg\level.cfg');
  Reset(f);
  LevelCount := 0;
  while not eof(f) do begin
    inc(LevelCount);
    SetLength(Levels,LevelCount);
    ReadLn(f,Levels[LevelCount-1]);
  end;
  CloseFile(f);
end;

destructor TLevelManager.Destroy;
begin

  inherited Destroy;
end;

procedure TLevelManager.NewGame(__Type : TLevelType);
begin
  _Type := __Type;
  case _Type of
    ltTime: LevelDelay := LevelToTimeDelay;
    ltWiner: LevelDelay := LevelWinerDelay;
  end;
  Game.Channel := Game.Music.Play(true,Options.MusicVolume);
  World_Init();
  LevelTime := 0;
  PrepareTime := 0;
  LevelCurrent := 0;
  Map.Load(levels[LevelCurrent]);
  LevelTime := 0;
  isPlaying := true;
  Game.Pause := false;
  Finish := false;
end;

procedure TLevelManager.NextLevel;
begin
  case _Type of
    ltTime: LevelDelay := LevelToTimeDelay;
    ltWiner: LevelDelay := LevelWinerDelay;
  end;
  LevelTime := 0;
  PrepareTime := 0;
  inc(LevelCurrent);
  Map.Load(levels[LevelCurrent]);
  BallMan.Clear;
  ParticleManager.KillAll;
  Gun.Init(398*WndAspect, 312*WndAspect);
  LevelTime := 0;
  isPlaying := true;
  Game.Pause := false;
  Finish := false;
end;

procedure TLevelManager.LevelEnd;
begin
  Game.Pause := true;
  Finish := true;
  isPlaying := false;
  if LevelCurrent < LevelCount-1 then NextLevel else GameOver;
end;

procedure TLevelManager.GameOver;
begin
  TOP.Check(Profile.PlayerName,Profile.Score,Game.GamePlayColorAll[random(7)],ord(ltTime));
  Top.SaveTOP;
end;

procedure TLevelManager.Update(const delta : single);
begin
  if not Game.Pause then
  if isPlaying then begin
    //LevelTime := LevelTime + delta;
   // if LevelTime > PrepareDelay then begin
    {case _Type of
      ltTime:  LevelEnd;
      ltWiner: begin
        PlayerManager.LoserDead;
        LevelTime := 0;
        inc(LoserCount);
        if (TPlayer(PlayerManager.List.Items[PlayerManager.Players[0]])._State = psDead) then
         if not Game.TwoPlayer then LevelEnd else
           if (TPlayer(PlayerManager.List.Items[PlayerManager.Players[1]])._State = psDead) then
             LevelEnd;
        if PlayerManager.List.Count=LoserCount+1 then LevelEnd;
      end;
    end;   }
      //TimeToNormalTime(round(LevelDelay-LevelTime),day,hour,minute,second);
      World_Update(delta);
    //end;
  end;
end;

end.
