unit g_Profile;

interface
uses
  Classes,
  HGE,HGEFont,
  g_cfg,g_utils;

type
   TProfile = class
     PlayerName : string[9];
     Score,tScore : integer;
     stringScore : String[15];
     Color : Cardinal;
     FilePath : string;
     bEnterName1 : boolean;
     NameLength : byte;
     constructor Create;
     procedure Init;
     procedure Load;
     procedure EnterName;
     procedure Save;
     procedure PasteDot;
     procedure Render;
     procedure Update;
   end;

implementation
uses
  g_Types,g_gui;

constructor TProfile.Create;
begin
  inherited;
  bEnterName1 := false;
  Score := 0;
  tScore := 0;
  FilePath := 'data\cfg\profile.cfg';
  NameLength := 9;
end;

procedure TProfile.Init;
begin
  Score := 0;
  tScore := 0;
end;

procedure TProfile.Load;
var
  f : file of byte;
begin
  AssignFile(f,FilePath);
  Reset(f);
  blockRead(f,PlayerName,sizeof(PlayerName));
  CloseFile(f);
end;

procedure TProfile.Save;
var
  f : file of byte;
begin
  AssignFile(f,FilePath);
  Rewrite(f);
  blockWrite(f,PlayerName,sizeof(PlayerName));
  CloseFile(f);
end;

procedure TProfile.EnterName;
var name : string[9];
begin
  if bEnterName1 then begin
    if bEnterName1 then Name := PlayerName;
    if Length(Name) < 9 then
    if (_HGE.Input_GetChar <> $0) and (_HGE.Input_GetChar <> HGEK_BACKSPACE)
    and(_HGE.Input_GetChar <> $0D)and (_HGE.Input_GetChar <> HGEK_ESCAPE)
    and(_HGE.Input_GetChar <> $09) then
      Name := Name+chr(_HGE.Input_GetChar);
    //Baskspace\\
    if _HGE.Input_KeyUp(HGEK_BACKSPACE) then Delete(Name,Length(Name),1);
    //Enter\\
    {if Input.Keys[$0D] then begin
      if Text[CurrStr] <> '' then begin
        LastCommand := Text[CurrStr];
        AddString(Text[CurrStr]);
        s := Execute(Text[CurrStr-1]);
        if s  <> '' then AddString(s);
      end;
      Input.Keys[$0D] := false;
    end;       }
    if bEnterName1 then PlayerName := Name;
  end;
end;

procedure TProfile.PasteDot;
var
  str : string;
  I,j,len,k: Integer;
begin
  str := InttoStr(Score);
  len := length(str);
  stringScore := '';
  k := len mod 3;
  j := 3-k;
  i := 1;
  if j = 3 then begin
    stringScore := stringScore + str[1];
    j := 1;
    i := 2;
  end;
  while i <= len  do begin
     if (j=3) then begin
       stringScore := stringScore + '.';
       stringScore := stringScore + str[i];
       j := 0;
     end else stringScore := stringScore + str[i];
    inc(i);
    inc(j);
  end;
end;

procedure TProfile.Render;
begin
  GUI.Fnt.SetColor($ffff7733);
  GUI.Fnt.PrintF(100*WndAspect,60*WndAspect,HGETEXT_CENTER,'Score :'#10#13 +'%s',[stringScore]);
end;

procedure TProfile.Update;
begin
  PasteDot;
  if Score < tScore then inc(Score,5) else
  if Score > tScore then dec(Score,5);
end;

end.
