//=============================================================================
//           : Half-Light
//   : g_Main.pas
//        :   
//            : Soulghai
//    : 18.10.2006
//       :   , /  
//                      
//=============================================================================
//            :   
//=============================================================================
unit g_Types;

interface
uses
  Windows,Classes,SysUtils,
  HGE,HGESprite,HGEParticle,HGEColor,
  g_LevelManager,g_Map, g_Profile;

const
  GAME_VERSION = 'v0.4';
  AppName = 'myffio '+ GAME_VERSION;
  GAME_TITLE = 'myffio '+ GAME_VERSION;
  STANDART_RESOLUTION_WIDTH = 1024;
  STANDART_RESOLUTION_HEGIHT = 768;
  SCREEN_SHOT = 'data\screenshot\';

var
  WND_WIDTH, WND_HEIGHT : word;
  SCR_CENTER_W,SCR_CENTER_H : word;
  GAME_GLOBAL_SPEED : single = 0.015;                                          //   0.025=50 /
  GAME_GLOBAL__TIME_OLD : single;                                              //   
  WndAspect : single;

type
  TGameState = (gsIntro,gsLoading,gsMenu,gsGame);

  TGame = record
    State : TGameState;
    Pause : boolean;                                                           //  ""
    ProfileCount : byte;
    ProfileCurrent : byte;
    Finish : boolean;                                                          //  true -    
    Music : IStream;
    Channel : IChannel;
    GameplayColorCount : byte;
    GameplayColorAll : array [0..6] of Cardinal;
    GameplayColor : array [0..6] of Cardinal;
    TexParticle : ITexture;
  end;

var
  _HGE : IHGE = nil;
  Game : TGame;
  LevelManager : TLevelManager;
  Profile : TProfile;
  Map : TMap;
  ParticleManager : IHGEParticleManager;

function ToggleParSys(var ParSys: IHGEParticleSystem; const Filename: String;
    Tex : ITexture; const TexX, TexY, Size, XPos, YPos: Integer;
    Blend : integer; StartColor : cardinal = $00000000;EndColor : cardinal = $00000000) : boolean;
procedure ParSysDelete( var ParSys : IHGEParticleSystem);
implementation

procedure ParSysDelete( var ParSys : IHGEParticleSystem);
begin
  if ParticleManager.IsPSAlive(ParSys) then begin
    ParticleManager.KillPS(ParSys);
    ParSys := nil;
  end
end;

function ToggleParSys(var ParSys: IHGEParticleSystem; const Filename: String;
    Tex : ITexture; const TexX, TexY, Size, XPos, YPos: Integer;
    Blend : integer; StartColor : cardinal = $00000000;EndColor : cardinal = $00000000) : boolean;
var
  Params: THGEParticleSystemInfo;
begin
  result := false;
  ParSysDelete(ParSys);
  begin
    Params.Sprite := THGESprite.Create(Tex,TexX,TexY,Size,Size);
    Params.Sprite.SetHotSpot(Size div 2,Size div 2);
    Params.Sprite.SetBlendMode(BLEND);
    with TFileStream.Create(Filename,fmOpenRead or fmShareDenyWrite) do try
      Position := 4;
      ReadBuffer(Params.Emission,SizeOf(Params) - 4);
    finally
      Free;
    end;
    if StartColor > $00000000 then begin
      Params.ColorStart.SetHWColor(StartColor);
      params.Sprite.SetColor($FFFFFFFF);
    end;
    if EndColor > $00000000 then begin
      Params.ColorEnd.SetHWColor(EndColor);
      params.Sprite.SetColor($FFFFFFFF);
    end;
    ParSys := ParticleManager.SpawnPS(Params,XPos,YPos);
    Result := true;
  end;
end;

initialization
  Profile := TProfile.Create;
  
end.
