unit g_gui;

interface
uses
  HGE,HGESprite,HGEFont,HGEParticle,
  g_Types,g_Hint,g_Options,g_cfg,g_math,
  g_bonus;

type
  TGUI = class
    Fnt,FntWiner : IHGEFont;
    PauseTex : ITexture;
    PauseSpr : IHGESprite;
    CursorTex :ITexture;
    CursorSpr : IHGESprite;
    CursorAngle : single;
    Hint,GamePlayHint,HintLevelName : THint;
    particle : IHGEParticleSystem;
    constructor Create;
    procedure GameRender;
  end;

var GUI : TGUI;

implementation

Constructor TGUI.Create;
begin
  inherited;
  Fnt := THGEFont.Create(Cfg_ReadStr('data\cfg\gui.cfg','FONT','data\fonts\default.fnt'));
  FntWiner := THGEFont.Create(Cfg_ReadStr('data\cfg\gui.cfg','FONT_WINER','data\fonts\winner.fnt'));
  Hint := THint.Create('data\fonts\default.fnt');
  GamePlayHint := THint.Create('data\fonts\default.fnt');
  Hint.Init;
  GamePlayHint.Init;
  GamePlayHint.SpdY := -1;
  HintLevelName := THint.Create('data\fonts\LevelName.fnt');
  HintLevelName.Init;
  HintLevelName.SpdY := 0;
  HintLevelName.Delay := 2;
  HintLevelName.levelling := 2;
  PauseTex := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\gui.cfg','TEXTURE_PAUSE','pause.png'));
  PauseSpr := THGESprite.Create(PauseTex,0,0,PauseTex.GetWidth,PauseTex.GetHeight);
  PauseSpr.SetHotSpot(PauseTex.GetWidth / 2,PauseTex.GetHeight / 2);
  CursorTex := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\gui.cfg','TEXTURE_CURSOR','cursor_hand.png'));
  CursorSpr := THGESprite.Create(CursorTex,0,0,CursorTex.GetWidth,CursorTex.GetHeight);
  CursorSpr.SetColor($ffffffff);
  CursorAngle := 0;
end;

procedure TGUI.GameRender;
var X,Y : single;
begin
  if Options.ShowFps then begin
    Fnt.SetColor($ffFF8833);
    Fnt.PrintF(WND_WIDTH,WND_HEIGHT-20,HGETEXT_RIGHT,'FPS:%d',[_HGE.Timer_GetFPS]);
  end;
  //ScorePanelSpr.RenderStretch(WND_WIDTH-12*16,0,WND_WIDTH,6*32);
  //ClockSpr.Render(0,0);
  //----------------------------------------------------------------------------
  // Game info
  //----------------------------------------------------------------------------
  if LevelManager.isPlaying and Game.Pause then begin
    PauseSpr.Render(SCR_CENTER_W,SCR_CENTER_H);
  end;
    // Clock
  {Fnt.SetColor($ffff8800);
  if LevelManager.Second < 10 then
    Fnt.PrintF(64,40,HGETEXT_CENTER,'%d:0%d',[LevelManager.Minute,LevelManager.Second])
  else
    Fnt.PrintF(64,40,HGETEXT_CENTER,'%d:%d',[LevelManager.Minute,LevelManager.Second]);}

  // Render Score
  Profile.Render;

  BonusManager.RenderGUI;
  if LevelManager.Finish then begin
    FntWiner.SetColor($ffff8833);
    FntWiner.PrintF(SCR_CENTER_W,SCR_CENTER_H,HGETEXT_RIGHT,'Winer is '#13' score :',[]);
    FntWiner.SetColor($ffff0088);
    {FntWiner.PrintF(SCR_CENTER_W,SCR_CENTER_H,HGETEXT_LEFT,'%s '#13' %d',
               [TPlayer(PlayerManager.List.Items[PlayerManager.LiderID]).Name,
               TPlayer(PlayerManager.List.Items[PlayerManager.LiderID]).Score]);  }
  end;
  GamePlayHint.Draw;
  HintLevelName.Draw;
  _HGE.Input_GetMousePos(X,Y);
  CursorSpr.RenderEx(X,Y,CursorAngle*deg2rad);
  if particle<>nil then
    particle.MoveTo(X+32*WndAspect*cos((CursorAngle+45)*deg2rad),Y+32*WndAspect*sin((CursorAngle+45)*deg2rad));
  //Hint.Draw;
end;

end.
